import win32.windows;
import win32.windef;
import win32.commctrl;

import std.stdio;
import std.string;
import std.utf;

import gmpp;

import SubPanel1 ;
import GraphicBase;

class GraphicFrame : GraphicBase {
  mpf  ox, oy, zoom ;
  mpf  offx, offy   ;
  bool posupdate=false ;
  SubPanel1  subpanel1 ;
  
  this(string name, string ClassName) {
    ox   = new mpf("0.0") ;
    oy   = new mpf("0.0") ;
    zoom = new mpf("1.0") ;
    super(name,ClassName) ;
  }

  int wm_create(){
    return(0) ;
  }

  int wm_paint(){
    return(0) ;
  }
  
  int wm_size(int w, int h){
    return(0) ;
  }
  
  int mouse( int acs_stat, int mb, int mx, int my ){
    mpf w = new mpf(getImageBufferWidth() ) ;
    mpf h = new mpf(getImageBufferHeight()) ;
    mpf mpfmx = new mpf(mx) ;
    mpf mpfmy = new mpf(my) ;
    mpf tmpoffx = 4*(mpfmx - w/2)/(zoom*w) + ox  ;
    mpf tmpoffy = 4*(mpfmy - h/2)/(zoom*w) + oy  ;
    
    if( (mb & WM_LBUTTONUP) == 0 ){
      if( (mb & WM_LBUTTONDOWN) != 0 ){
	offx = tmpoffx ;
	offy = tmpoffy ;
	sendmsg(subpanel1.getHWND(), WM_COMMAND, 0x201, 0) ;
      }
    }
    //printStatusbar( format("%f %f : off %s %s",
    //  cast(double)(mx),cast(double)(my), offx, offy) ) ;
    return(0) ;
  }

  int setSubPanel1(SubPanel1 sp1){
    subpanel1 = sp1 ;
    return(0) ;
  }

  int setMandelPos(double ox, double oy, double zoom){
    this.ox   = new mpf(ox) ;
    this.oy   = new mpf(oy) ;
    this.zoom = new mpf(zoom) ;
    return(0) ;
  }

  int setMandelPos(mpf ox, mpf oy, mpf zoom){
    this.ox   = ox ;
    this.oy   = oy ;
    this.zoom = zoom ;
    return(0) ;
  }
  
}
