import win32.windows;
import std.string;
import std.stdio;
import win32frame.writek;
import win32frame.WindowObject ;


class Panel : WindowObject {
  this(string name, int mode=0) {
    winc.style          = 0; //CS_HREDRAW | CS_VREDRAW ;
    this.setStyle(WS_CHILD | WS_TABSTOP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE) ;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.lpszMenuName   = null;
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    winc.hbrBackground  = CreateSolidBrush(GetSysColor(COLOR_3DFACE)) ; //cast(HBRUSH)(GetStockObject(BLACK_BRUSH));
    winc.lpszClassName  = cast(wchar*)("Panel") ;
    super(name) ;
    this.registwinc() ;
  }

  override LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch( msg ){    
    case WM_NOTIFY:
    case WM_HSCROLL:
    case WM_VSCROLL:
    case WM_COMMAND:
      sendmsgtoparent(msg, wp,lp) ;
      break ;
      
    default : break ;
    }
    return( DefWindowProc(hwnd , msg , wp , lp) ) ;
  }
  
}
