import win32.windows;
import std.stdio;
import win32frame.writek;

extern (C) :

/* ----------------------------- GL_VERSION_1_1 ---------------------------- */
alias uint   GLenum;
alias uint   GLbitfield;
alias uint   GLuint;
alias int    GLint;
alias int    GLsizei;
alias ubyte  GLboolean;
alias byte   GLbyte;
alias short  GLshort;
alias ubyte  GLubyte;
alias ushort GLushort;
alias uint   GLulong;
alias float  GLfloat;
alias float  GLclampf;
alias double GLdouble;
alias double GLclampd;
alias void   GLvoid;
alias long   GLint64;
alias ulong  GLuint64;

alias ubyte  uchar;

const uint GL_ACCUM                         = 0x0100 ;
const uint GL_LOAD                          = 0x0101 ;
const uint GL_RETURN                        = 0x0102 ;
const uint GL_MULT                          = 0x0103 ;
const uint GL_ADD                           = 0x0104 ;
const uint GL_NEVER                         = 0x0200 ;
const uint GL_LESS                          = 0x0201 ;
const uint GL_EQUAL                         = 0x0202 ;
const uint GL_LEQUAL                        = 0x0203 ;
const uint GL_GREATER                       = 0x0204 ;
const uint GL_NOTEQUAL                      = 0x0205 ;
const uint GL_GEQUAL                        = 0x0206 ;
const uint GL_ALWAYS                        = 0x0207 ;
const uint GL_CURRENT_BIT                   = 0x00000001 ;
const uint GL_POINT_BIT                     = 0x00000002 ;
const uint GL_LINE_BIT                      = 0x00000004 ;
const uint GL_POLYGON_BIT                   = 0x00000008 ;
const uint GL_POLYGON_STIPPLE_BIT           = 0x00000010 ;
const uint GL_PIXEL_MODE_BIT                = 0x00000020 ;
const uint GL_LIGHTING_BIT                  = 0x00000040 ;
const uint GL_FOG_BIT                       = 0x00000080 ;
const uint GL_DEPTH_BUFFER_BIT              = 0x00000100 ;
const uint GL_ACCUM_BUFFER_BIT              = 0x00000200 ;
const uint GL_STENCIL_BUFFER_BIT            = 0x00000400 ;
const uint GL_VIEWPORT_BIT                  = 0x00000800 ;
const uint GL_TRANSFORM_BIT                 = 0x00001000 ;
const uint GL_ENABLE_BIT                    = 0x00002000 ;
const uint GL_COLOR_BUFFER_BIT              = 0x00004000 ;
const uint GL_HINT_BIT                      = 0x00008000 ;
const uint GL_EVAL_BIT                      = 0x00010000 ;
const uint GL_LIST_BIT                      = 0x00020000 ;
const uint GL_TEXTURE_BIT                   = 0x00040000 ;
const uint GL_SCISSOR_BIT                   = 0x00080000 ;
const uint GL_ALL_ATTRIB_BITS               = 0x000fffff ;
const uint GL_POINTS                        = 0x0000 ;
const uint GL_LINES                         = 0x0001 ;
const uint GL_LINE_LOOP                     = 0x0002 ;
const uint GL_LINE_STRIP                    = 0x0003 ;
const uint GL_TRIANGLES                     = 0x0004 ;
const uint GL_TRIANGLE_STRIP                = 0x0005 ;
const uint GL_TRIANGLE_FAN                  = 0x0006 ;
const uint GL_QUADS                         = 0x0007 ;
const uint GL_QUAD_STRIP                    = 0x0008 ;
const uint GL_POLYGON                       = 0x0009 ;
const uint GL_ZERO                          = 0 ;
const uint GL_ONE                           = 1 ;
const uint GL_SRC_COLOR                     = 0x0300 ;
const uint GL_ONE_MINUS_SRC_COLOR           = 0x0301 ;
const uint GL_SRC_ALPHA                     = 0x0302 ;
const uint GL_ONE_MINUS_SRC_ALPHA           = 0x0303 ;
const uint GL_DST_ALPHA                     = 0x0304 ;
const uint GL_ONE_MINUS_DST_ALPHA           = 0x0305 ;
const uint GL_DST_COLOR                     = 0x0306 ;
const uint GL_ONE_MINUS_DST_COLOR           = 0x0307 ;
const uint GL_SRC_ALPHA_SATURATE            = 0x0308 ;
const uint GL_TRUE                          = 1 ;
const uint GL_FALSE                         = 0 ;
const uint GL_CLIP_PLANE0                   = 0x3000 ;
const uint GL_CLIP_PLANE1                   = 0x3001 ;
const uint GL_CLIP_PLANE2                   = 0x3002 ;
const uint GL_CLIP_PLANE3                   = 0x3003 ;
const uint GL_CLIP_PLANE4                   = 0x3004 ;
const uint GL_CLIP_PLANE5                   = 0x3005 ;
const uint GL_BYTE                          = 0x1400 ;
const uint GL_UNSIGNED_BYTE                 = 0x1401 ;
const uint GL_SHORT                         = 0x1402 ;
const uint GL_UNSIGNED_SHORT                = 0x1403 ;
const uint GL_INT                           = 0x1404 ;
const uint GL_UNSIGNED_INT                  = 0x1405 ;
const uint GL_FLOAT                         = 0x1406 ;
const uint GL_2_BYTES                       = 0x1407 ;
const uint GL_3_BYTES                       = 0x1408 ;
const uint GL_4_BYTES                       = 0x1409 ;
const uint GL_DOUBLE                        = 0x140A ;
const uint GL_NONE                          = 0 ;
const uint GL_FRONT_LEFT                    = 0x0400 ;
const uint GL_FRONT_RIGHT                   = 0x0401 ;
const uint GL_BACK_LEFT                     = 0x0402 ;
const uint GL_BACK_RIGHT                    = 0x0403 ;
const uint GL_FRONT                         = 0x0404 ;
const uint GL_BACK                          = 0x0405 ;
const uint GL_LEFT                          = 0x0406 ;
const uint GL_RIGHT                         = 0x0407 ;
const uint GL_FRONT_AND_BACK                = 0x0408 ;
const uint GL_AUX0                          = 0x0409 ;
const uint GL_AUX1                          = 0x040A ;
const uint GL_AUX2                          = 0x040B ;
const uint GL_AUX3                          = 0x040C ;
const uint GL_NO_ERROR                      = 0 ;
const uint GL_INVALID_ENUM                  = 0x0500 ;
const uint GL_INVALID_VALUE                 = 0x0501 ;
const uint GL_INVALID_OPERATION             = 0x0502 ;
const uint GL_STACK_OVERFLOW                = 0x0503 ;
const uint GL_STACK_UNDERFLOW               = 0x0504 ;
const uint GL_OUT_OF_MEMORY                 = 0x0505 ;
const uint GL_2D                            = 0x0600 ;
const uint GL_3D                            = 0x0601 ;
const uint GL_3D_COLOR                      = 0x0602 ;
const uint GL_3D_COLOR_TEXTURE              = 0x0603 ;
const uint GL_4D_COLOR_TEXTURE              = 0x0604 ;
const uint GL_PASS_THROUGH_TOKEN            = 0x0700 ;
const uint GL_POINT_TOKEN                   = 0x0701 ;
const uint GL_LINE_TOKEN                    = 0x0702 ;
const uint GL_POLYGON_TOKEN                 = 0x0703 ;
const uint GL_BITMAP_TOKEN                  = 0x0704 ;
const uint GL_DRAW_PIXEL_TOKEN              = 0x0705 ;
const uint GL_COPY_PIXEL_TOKEN              = 0x0706 ;
const uint GL_LINE_RESET_TOKEN              = 0x0707 ;
const uint GL_EXP                           = 0x0800 ;
const uint GL_EXP2                          = 0x0801 ;
const uint GL_CW                            = 0x0900 ;
const uint GL_CCW                           = 0x0901 ;
const uint GL_COEFF                         = 0x0A00 ;
const uint GL_ORDER                         = 0x0A01 ;
const uint GL_DOMAIN                        = 0x0A02 ;
const uint GL_CURRENT_COLOR                 = 0x0B00 ;
const uint GL_CURRENT_INDEX                 = 0x0B01 ;
const uint GL_CURRENT_NORMAL                = 0x0B02 ;
const uint GL_CURRENT_TEXTURE_COORDS        = 0x0B03 ;
const uint GL_CURRENT_RASTER_COLOR          = 0x0B04 ;
const uint GL_CURRENT_RASTER_INDEX          = 0x0B05 ;
const uint GL_CURRENT_RASTER_TEXTURE_COORDS = 0x0B06 ;
const uint GL_CURRENT_RASTER_POSITION       = 0x0B07 ;
const uint GL_CURRENT_RASTER_POSITION_VALID = 0x0B08 ;
const uint GL_CURRENT_RASTER_DISTANCE       = 0x0B09 ;
const uint GL_POINT_SMOOTH                  = 0x0B10 ;
const uint GL_POINT_SIZE                    = 0x0B11 ;
const uint GL_POINT_SIZE_RANGE              = 0x0B12 ;
const uint GL_POINT_SIZE_GRANULARITY        = 0x0B13 ;
const uint GL_LINE_SMOOTH                   = 0x0B20 ;
const uint GL_LINE_WIDTH                    = 0x0B21 ;
const uint GL_LINE_WIDTH_RANGE              = 0x0B22 ;
const uint GL_LINE_WIDTH_GRANULARITY        = 0x0B23 ;
const uint GL_LINE_STIPPLE                  = 0x0B24 ;
const uint GL_LINE_STIPPLE_PATTERN          = 0x0B25 ;
const uint GL_LINE_STIPPLE_REPEAT           = 0x0B26 ;
const uint GL_LIST_MODE                     = 0x0B30 ;
const uint GL_MAX_LIST_NESTING              = 0x0B31 ;
const uint GL_LIST_BASE                     = 0x0B32 ;
const uint GL_LIST_INDEX                    = 0x0B33 ;
const uint GL_POLYGON_MODE                  = 0x0B40 ;
const uint GL_POLYGON_SMOOTH                = 0x0B41 ;
const uint GL_POLYGON_STIPPLE               = 0x0B42 ;
const uint GL_EDGE_FLAG                     = 0x0B43 ;
const uint GL_CULL_FACE                     = 0x0B44 ;
const uint GL_CULL_FACE_MODE                = 0x0B45 ;
const uint GL_FRONT_FACE                    = 0x0B46 ;
const uint GL_LIGHTING                      = 0x0B50 ;
const uint GL_LIGHT_MODEL_LOCAL_VIEWER      = 0x0B51 ;
const uint GL_LIGHT_MODEL_TWO_SIDE          = 0x0B52 ;
const uint GL_LIGHT_MODEL_AMBIENT           = 0x0B53 ;
const uint GL_SHADE_MODEL                   = 0x0B54 ;
const uint GL_COLOR_MATERIAL_FACE           = 0x0B55 ;
const uint GL_COLOR_MATERIAL_PARAMETER      = 0x0B56 ;
const uint GL_COLOR_MATERIAL                = 0x0B57 ;
const uint GL_FOG                           = 0x0B60 ;
const uint GL_FOG_INDEX                     = 0x0B61 ;
const uint GL_FOG_DENSITY                   = 0x0B62 ;
const uint GL_FOG_START                     = 0x0B63 ;
const uint GL_FOG_END                       = 0x0B64 ;
const uint GL_FOG_MODE                      = 0x0B65 ;
const uint GL_FOG_COLOR                     = 0x0B66 ;
const uint GL_DEPTH_RANGE                   = 0x0B70 ;
const uint GL_DEPTH_TEST                    = 0x0B71 ;
const uint GL_DEPTH_WRITEMASK               = 0x0B72 ;
const uint GL_DEPTH_CLEAR_VALUE             = 0x0B73 ;
const uint GL_DEPTH_FUNC                    = 0x0B74 ;
const uint GL_ACCUM_CLEAR_VALUE             = 0x0B80 ;
const uint GL_STENCIL_TEST                  = 0x0B90 ;
const uint GL_STENCIL_CLEAR_VALUE           = 0x0B91 ;
const uint GL_STENCIL_FUNC                  = 0x0B92 ;
const uint GL_STENCIL_VALUE_MASK            = 0x0B93 ;
const uint GL_STENCIL_FAIL                  = 0x0B94 ;
const uint GL_STENCIL_PASS_DEPTH_FAIL       = 0x0B95 ;
const uint GL_STENCIL_PASS_DEPTH_PASS       = 0x0B96 ;
const uint GL_STENCIL_REF                   = 0x0B97 ;
const uint GL_STENCIL_WRITEMASK             = 0x0B98 ;
const uint GL_MATRIX_MODE                   = 0x0BA0 ;
const uint GL_NORMALIZE                     = 0x0BA1 ;
const uint GL_VIEWPORT                      = 0x0BA2 ;
const uint GL_MODELVIEW_STACK_DEPTH         = 0x0BA3 ;
const uint GL_PROJECTION_STACK_DEPTH        = 0x0BA4 ;
const uint GL_TEXTURE_STACK_DEPTH           = 0x0BA5 ;
const uint GL_MODELVIEW_MATRIX              = 0x0BA6 ;
const uint GL_PROJECTION_MATRIX             = 0x0BA7 ;
const uint GL_TEXTURE_MATRIX                = 0x0BA8 ;
const uint GL_ATTRIB_STACK_DEPTH            = 0x0BB0 ;
const uint GL_CLIENT_ATTRIB_STACK_DEPTH     = 0x0BB1 ;
const uint GL_ALPHA_TEST                    = 0x0BC0 ;
const uint GL_ALPHA_TEST_FUNC               = 0x0BC1 ;
const uint GL_ALPHA_TEST_REF                = 0x0BC2 ;
const uint GL_DITHER                        = 0x0BD0 ;
const uint GL_BLEND_DST                     = 0x0BE0 ;
const uint GL_BLEND_SRC                     = 0x0BE1 ;
const uint GL_BLEND                         = 0x0BE2 ;
const uint GL_LOGIC_OP_MODE                 = 0x0BF0 ;
const uint GL_INDEX_LOGIC_OP                = 0x0BF1 ;
const uint GL_COLOR_LOGIC_OP                = 0x0BF2 ;
const uint GL_AUX_BUFFERS                   = 0x0C00 ;
const uint GL_DRAW_BUFFER                   = 0x0C01 ;
const uint GL_READ_BUFFER                   = 0x0C02 ;
const uint GL_SCISSOR_BOX                   = 0x0C10 ;
const uint GL_SCISSOR_TEST                  = 0x0C11 ;
const uint GL_INDEX_CLEAR_VALUE             = 0x0C20 ;
const uint GL_INDEX_WRITEMASK               = 0x0C21 ;
const uint GL_COLOR_CLEAR_VALUE             = 0x0C22 ;
const uint GL_COLOR_WRITEMASK               = 0x0C23 ;
const uint GL_INDEX_MODE                    = 0x0C30 ;
const uint GL_RGBA_MODE                     = 0x0C31 ;
const uint GL_DOUBLEBUFFER                  = 0x0C32 ;
const uint GL_STEREO                        = 0x0C33 ;
const uint GL_RENDER_MODE                   = 0x0C40 ;
const uint GL_PERSPECTIVE_CORRECTION_HINT   = 0x0C50 ;
const uint GL_POINT_SMOOTH_HINT             = 0x0C51 ;
const uint GL_LINE_SMOOTH_HINT              = 0x0C52 ;
const uint GL_POLYGON_SMOOTH_HINT           = 0x0C53 ;
const uint GL_FOG_HINT                      = 0x0C54 ;
const uint GL_TEXTURE_GEN_S                 = 0x0C60 ;
const uint GL_TEXTURE_GEN_T                 = 0x0C61 ;
const uint GL_TEXTURE_GEN_R                 = 0x0C62 ;
const uint GL_TEXTURE_GEN_Q                 = 0x0C63 ;
const uint GL_PIXEL_MAP_I_TO_I              = 0x0C70 ;
const uint GL_PIXEL_MAP_S_TO_S              = 0x0C71 ;
const uint GL_PIXEL_MAP_I_TO_R              = 0x0C72 ;
const uint GL_PIXEL_MAP_I_TO_G              = 0x0C73 ;
const uint GL_PIXEL_MAP_I_TO_B              = 0x0C74 ;
const uint GL_PIXEL_MAP_I_TO_A              = 0x0C75 ;
const uint GL_PIXEL_MAP_R_TO_R              = 0x0C76 ;
const uint GL_PIXEL_MAP_G_TO_G              = 0x0C77 ;
const uint GL_PIXEL_MAP_B_TO_B              = 0x0C78 ;
const uint GL_PIXEL_MAP_A_TO_A              = 0x0C79 ;
const uint GL_PIXEL_MAP_I_TO_I_SIZE         = 0x0CB0 ;
const uint GL_PIXEL_MAP_S_TO_S_SIZE         = 0x0CB1 ;
const uint GL_PIXEL_MAP_I_TO_R_SIZE         = 0x0CB2 ;
const uint GL_PIXEL_MAP_I_TO_G_SIZE         = 0x0CB3 ;
const uint GL_PIXEL_MAP_I_TO_B_SIZE         = 0x0CB4 ;
const uint GL_PIXEL_MAP_I_TO_A_SIZE         = 0x0CB5 ;
const uint GL_PIXEL_MAP_R_TO_R_SIZE         = 0x0CB6 ;
const uint GL_PIXEL_MAP_G_TO_G_SIZE         = 0x0CB7 ;
const uint GL_PIXEL_MAP_B_TO_B_SIZE         = 0x0CB8 ;
const uint GL_PIXEL_MAP_A_TO_A_SIZE         = 0x0CB9 ;
const uint GL_UNPACK_SWAP_BYTES             = 0x0CF0 ;
const uint GL_UNPACK_LSB_FIRST              = 0x0CF1 ;
const uint GL_UNPACK_ROW_LENGTH             = 0x0CF2 ;
const uint GL_UNPACK_SKIP_ROWS              = 0x0CF3 ;
const uint GL_UNPACK_SKIP_PIXELS            = 0x0CF4 ;
const uint GL_UNPACK_ALIGNMENT              = 0x0CF5 ;
const uint GL_PACK_SWAP_BYTES               = 0x0D00 ;
const uint GL_PACK_LSB_FIRST                = 0x0D01 ;
const uint GL_PACK_ROW_LENGTH               = 0x0D02 ;
const uint GL_PACK_SKIP_ROWS                = 0x0D03 ;
const uint GL_PACK_SKIP_PIXELS              = 0x0D04 ;
const uint GL_PACK_ALIGNMENT                = 0x0D05 ;
const uint GL_MAP_COLOR                     = 0x0D10 ;
const uint GL_MAP_STENCIL                   = 0x0D11 ;
const uint GL_INDEX_SHIFT                   = 0x0D12 ;
const uint GL_INDEX_OFFSET                  = 0x0D13 ;
const uint GL_RED_SCALE                     = 0x0D14 ;
const uint GL_RED_BIAS                      = 0x0D15 ;
const uint GL_ZOOM_X                        = 0x0D16 ;
const uint GL_ZOOM_Y                        = 0x0D17 ;
const uint GL_GREEN_SCALE                   = 0x0D18 ;
const uint GL_GREEN_BIAS                    = 0x0D19 ;
const uint GL_BLUE_SCALE                    = 0x0D1A ;
const uint GL_BLUE_BIAS                     = 0x0D1B ;
const uint GL_ALPHA_SCALE                   = 0x0D1C ;
const uint GL_ALPHA_BIAS                    = 0x0D1D ;
const uint GL_DEPTH_SCALE                   = 0x0D1E ;
const uint GL_DEPTH_BIAS                    = 0x0D1F ;
const uint GL_MAX_EVAL_ORDER                = 0x0D30 ;
const uint GL_MAX_LIGHTS                    = 0x0D31 ;
const uint GL_MAX_CLIP_PLANES               = 0x0D32 ;
const uint GL_MAX_TEXTURE_SIZE              = 0x0D33 ;
const uint GL_MAX_PIXEL_MAP_TABLE           = 0x0D34 ;
const uint GL_MAX_ATTRIB_STACK_DEPTH        = 0x0D35 ;
const uint GL_MAX_MODELVIEW_STACK_DEPTH     = 0x0D36 ;
const uint GL_MAX_NAME_STACK_DEPTH          = 0x0D37 ;
const uint GL_MAX_PROJECTION_STACK_DEPTH    = 0x0D38 ;
const uint GL_MAX_TEXTURE_STACK_DEPTH       = 0x0D39 ;
const uint GL_MAX_VIEWPORT_DIMS             = 0x0D3A ;
const uint GL_MAX_CLIENT_ATTRIB_STACK_DEPTH = 0x0D3B ;
const uint GL_SUBPIXEL_BITS                 = 0x0D50 ;
const uint GL_INDEX_BITS                    = 0x0D51 ;
const uint GL_RED_BITS                      = 0x0D52 ;
const uint GL_GREEN_BITS                    = 0x0D53 ;
const uint GL_BLUE_BITS                     = 0x0D54 ;
const uint GL_ALPHA_BITS                    = 0x0D55 ;
const uint GL_DEPTH_BITS                    = 0x0D56 ;
const uint GL_STENCIL_BITS                  = 0x0D57 ;
const uint GL_ACCUM_RED_BITS                = 0x0D58 ;
const uint GL_ACCUM_GREEN_BITS              = 0x0D59 ;
const uint GL_ACCUM_BLUE_BITS               = 0x0D5A ;
const uint GL_ACCUM_ALPHA_BITS              = 0x0D5B ;
const uint GL_NAME_STACK_DEPTH              = 0x0D70 ;
const uint GL_AUTO_NORMAL                   = 0x0D80 ;
const uint GL_MAP1_COLOR_4                  = 0x0D90 ;
const uint GL_MAP1_INDEX                    = 0x0D91 ;
const uint GL_MAP1_NORMAL                   = 0x0D92 ;
const uint GL_MAP1_TEXTURE_COORD_1          = 0x0D93 ;
const uint GL_MAP1_TEXTURE_COORD_2          = 0x0D94 ;
const uint GL_MAP1_TEXTURE_COORD_3          = 0x0D95 ;
const uint GL_MAP1_TEXTURE_COORD_4          = 0x0D96 ;
const uint GL_MAP1_VERTEX_3                 = 0x0D97 ;
const uint GL_MAP1_VERTEX_4                 = 0x0D98 ;
const uint GL_MAP2_COLOR_4                  = 0x0DB0 ;
const uint GL_MAP2_INDEX                    = 0x0DB1 ;
const uint GL_MAP2_NORMAL                   = 0x0DB2 ;
const uint GL_MAP2_TEXTURE_COORD_1          = 0x0DB3 ;
const uint GL_MAP2_TEXTURE_COORD_2          = 0x0DB4 ;
const uint GL_MAP2_TEXTURE_COORD_3          = 0x0DB5 ;
const uint GL_MAP2_TEXTURE_COORD_4          = 0x0DB6 ;
const uint GL_MAP2_VERTEX_3                 = 0x0DB7 ;
const uint GL_MAP2_VERTEX_4                 = 0x0DB8 ;
const uint GL_MAP1_GRID_DOMAIN              = 0x0DD0 ;
const uint GL_MAP1_GRID_SEGMENTS            = 0x0DD1 ;
const uint GL_MAP2_GRID_DOMAIN              = 0x0DD2 ;
const uint GL_MAP2_GRID_SEGMENTS            = 0x0DD3 ;
const uint GL_TEXTURE_1D                    = 0x0DE0 ;
const uint GL_TEXTURE_2D                    = 0x0DE1 ;
const uint GL_FEEDBACK_BUFFER_POINTER       = 0x0DF0 ;
const uint GL_FEEDBACK_BUFFER_SIZE          = 0x0DF1 ;
const uint GL_FEEDBACK_BUFFER_TYPE          = 0x0DF2 ;
const uint GL_SELECTION_BUFFER_POINTER      = 0x0DF3 ;
const uint GL_SELECTION_BUFFER_SIZE         = 0x0DF4 ;
const uint GL_TEXTURE_WIDTH                 = 0x1000 ;
const uint GL_TEXTURE_HEIGHT                = 0x1001 ;
const uint GL_TEXTURE_INTERNAL_FORMAT       = 0x1003 ;
const uint GL_TEXTURE_BORDER_COLOR          = 0x1004 ;
const uint GL_TEXTURE_BORDER                = 0x1005 ;
const uint GL_DONT_CARE                     = 0x1100 ;
const uint GL_FASTEST                       = 0x1101 ;
const uint GL_NICEST                        = 0x1102 ;
const uint GL_LIGHT0                        = 0x4000 ;
const uint GL_LIGHT1                        = 0x4001 ;
const uint GL_LIGHT2                        = 0x4002 ;
const uint GL_LIGHT3                        = 0x4003 ;
const uint GL_LIGHT4                        = 0x4004 ;
const uint GL_LIGHT5                        = 0x4005 ;
const uint GL_LIGHT6                        = 0x4006 ;
const uint GL_LIGHT7                        = 0x4007 ;
const uint GL_AMBIENT                       = 0x1200 ;
const uint GL_DIFFUSE                       = 0x1201 ;
const uint GL_SPECULAR                      = 0x1202 ;
const uint GL_POSITION                      = 0x1203 ;
const uint GL_SPOT_DIRECTION                = 0x1204 ;
const uint GL_SPOT_EXPONENT                 = 0x1205 ;
const uint GL_SPOT_CUTOFF                   = 0x1206 ;
const uint GL_CONSTANT_ATTENUATION          = 0x1207 ;
const uint GL_LINEAR_ATTENUATION            = 0x1208 ;
const uint GL_QUADRATIC_ATTENUATION         = 0x1209 ;
const uint GL_COMPILE                       = 0x1300 ;
const uint GL_COMPILE_AND_EXECUTE           = 0x1301 ;
const uint GL_CLEAR                         = 0x1500 ;
const uint GL_AND                           = 0x1501 ;
const uint GL_AND_REVERSE                   = 0x1502 ;
const uint GL_COPY                          = 0x1503 ;
const uint GL_AND_INVERTED                  = 0x1504 ;
const uint GL_NOOP                          = 0x1505 ;
const uint GL_XOR                           = 0x1506 ;
const uint GL_OR                            = 0x1507 ;
const uint GL_NOR                           = 0x1508 ;
const uint GL_EQUIV                         = 0x1509 ;
const uint GL_INVERT                        = 0x150A ;
const uint GL_OR_REVERSE                    = 0x150B ;
const uint GL_COPY_INVERTED                 = 0x150C ;
const uint GL_OR_INVERTED                   = 0x150D ;
const uint GL_NAND                          = 0x150E ;
const uint GL_SET                           = 0x150F ;
const uint GL_EMISSION                      = 0x1600 ;
const uint GL_SHININESS                     = 0x1601 ;
const uint GL_AMBIENT_AND_DIFFUSE           = 0x1602 ;
const uint GL_COLOR_INDEXES                 = 0x1603 ;
const uint GL_MODELVIEW                     = 0x1700 ;
const uint GL_PROJECTION                    = 0x1701 ;
const uint GL_TEXTURE                       = 0x1702 ;
const uint GL_COLOR                         = 0x1800 ;
const uint GL_DEPTH                         = 0x1801 ;
const uint GL_STENCIL                       = 0x1802 ;
const uint GL_COLOR_INDEX                   = 0x1900 ;
const uint GL_STENCIL_INDEX                 = 0x1901 ;
const uint GL_DEPTH_COMPONENT               = 0x1902 ;
const uint GL_RED                           = 0x1903 ;
const uint GL_GREEN                         = 0x1904 ;
const uint GL_BLUE                          = 0x1905 ;
const uint GL_ALPHA                         = 0x1906 ;
const uint GL_RGB                           = 0x1907 ;
const uint GL_RGBA                          = 0x1908 ;
const uint GL_LUMINANCE                     = 0x1909 ;
const uint GL_LUMINANCE_ALPHA               = 0x190A ;
const uint GL_BITMAP                        = 0x1A00 ;
const uint GL_POINT                         = 0x1B00 ;
const uint GL_LINE                          = 0x1B01 ;
const uint GL_FILL                          = 0x1B02 ;
const uint GL_RENDER                        = 0x1C00 ;
const uint GL_FEEDBACK                      = 0x1C01 ;
const uint GL_SELECT                        = 0x1C02 ;
const uint GL_FLAT                          = 0x1D00 ;
const uint GL_SMOOTH                        = 0x1D01 ;
const uint GL_KEEP                          = 0x1E00 ;
const uint GL_REPLACE                       = 0x1E01 ;
const uint GL_INCR                          = 0x1E02 ;
const uint GL_DECR                          = 0x1E03 ;
const uint GL_VENDOR                        = 0x1F00 ;
const uint GL_RENDERER                      = 0x1F01 ;
const uint GL_VERSION                       = 0x1F02 ;
const uint GL_EXTENSIONS                    = 0x1F03 ;
const uint GL_S                             = 0x2000 ;
const uint GL_T                             = 0x2001 ;
const uint GL_R                             = 0x2002 ;
const uint GL_Q                             = 0x2003 ;
const uint GL_MODULATE                      = 0x2100 ;
const uint GL_DECAL                         = 0x2101 ;
const uint GL_TEXTURE_ENV_MODE              = 0x2200 ;
const uint GL_TEXTURE_ENV_COLOR             = 0x2201 ;
const uint GL_TEXTURE_ENV                   = 0x2300 ;
const uint GL_EYE_LINEAR                    = 0x2400 ;
const uint GL_OBJECT_LINEAR                 = 0x2401 ;
const uint GL_SPHERE_MAP                    = 0x2402 ;
const uint GL_TEXTURE_GEN_MODE              = 0x2500 ;
const uint GL_OBJECT_PLANE                  = 0x2501 ;
const uint GL_EYE_PLANE                     = 0x2502 ;
const uint GL_NEAREST                       = 0x2600 ;
const uint GL_LINEAR                        = 0x2601 ;
const uint GL_NEAREST_MIPMAP_NEAREST        = 0x2700 ;
const uint GL_LINEAR_MIPMAP_NEAREST         = 0x2701 ;
const uint GL_NEAREST_MIPMAP_LINEAR         = 0x2702 ;
const uint GL_LINEAR_MIPMAP_LINEAR          = 0x2703 ;
const uint GL_TEXTURE_MAG_FILTER            = 0x2800 ;
const uint GL_TEXTURE_MIN_FILTER            = 0x2801 ;
const uint GL_TEXTURE_WRAP_S                = 0x2802 ;
const uint GL_TEXTURE_WRAP_T                = 0x2803 ;
const uint GL_CLAMP                         = 0x2900 ;
const uint GL_REPEAT                        = 0x2901 ;
const uint GL_CLIENT_PIXEL_STORE_BIT        = 0x00000001 ;
const uint GL_CLIENT_VERTEX_ARRAY_BIT       = 0x00000002 ;
const uint GL_CLIENT_ALL_ATTRIB_BITS        = 0xffffffff ;
const uint GL_POLYGON_OFFSET_FACTOR         = 0x8038 ;
const uint GL_POLYGON_OFFSET_UNITS          = 0x2A00 ;
const uint GL_POLYGON_OFFSET_POINT          = 0x2A01 ;
const uint GL_POLYGON_OFFSET_LINE           = 0x2A02 ;
const uint GL_POLYGON_OFFSET_FILL           = 0x8037 ;
const uint GL_ALPHA4                        = 0x803B ;
const uint GL_ALPHA8                        = 0x803C ;
const uint GL_ALPHA12                       = 0x803D ;
const uint GL_ALPHA16                       = 0x803E ;
const uint GL_LUMINANCE4                    = 0x803F ;
const uint GL_LUMINANCE8                    = 0x8040 ;
const uint GL_LUMINANCE12                   = 0x8041 ;
const uint GL_LUMINANCE16                   = 0x8042 ;
const uint GL_LUMINANCE4_ALPHA4             = 0x8043 ;
const uint GL_LUMINANCE6_ALPHA2             = 0x8044 ;
const uint GL_LUMINANCE8_ALPHA8             = 0x8045 ;
const uint GL_LUMINANCE12_ALPHA4            = 0x8046 ;
const uint GL_LUMINANCE12_ALPHA12           = 0x8047 ;
const uint GL_LUMINANCE16_ALPHA16           = 0x8048 ;
const uint GL_INTENSITY                     = 0x8049 ;
const uint GL_INTENSITY4                    = 0x804A ;
const uint GL_INTENSITY8                    = 0x804B ;
const uint GL_INTENSITY12                   = 0x804C ;
const uint GL_INTENSITY16                   = 0x804D ;
const uint GL_R3_G3_B2                      = 0x2A10 ;
const uint GL_RGB4                          = 0x804F ;
const uint GL_RGB5                          = 0x8050 ;
const uint GL_RGB8                          = 0x8051 ;
const uint GL_RGB10                         = 0x8052 ;
const uint GL_RGB12                         = 0x8053 ;
const uint GL_RGB16                         = 0x8054 ;
const uint GL_RGBA2                         = 0x8055 ;
const uint GL_RGBA4                         = 0x8056 ;
const uint GL_RGB5_A1                       = 0x8057 ;
const uint GL_RGBA8                         = 0x8058 ;
const uint GL_RGB10_A2                      = 0x8059 ;
const uint GL_RGBA12                        = 0x805A ;
const uint GL_RGBA16                        = 0x805B ;
const uint GL_TEXTURE_RED_SIZE              = 0x805C ;
const uint GL_TEXTURE_GREEN_SIZE            = 0x805D ;
const uint GL_TEXTURE_BLUE_SIZE             = 0x805E ;
const uint GL_TEXTURE_ALPHA_SIZE            = 0x805F ;
const uint GL_TEXTURE_LUMINANCE_SIZE        = 0x8060 ;
const uint GL_TEXTURE_INTENSITY_SIZE        = 0x8061 ;
const uint GL_PROXY_TEXTURE_1D              = 0x8063 ;
const uint GL_PROXY_TEXTURE_2D              = 0x8064 ;
const uint GL_TEXTURE_PRIORITY              = 0x8066 ;
const uint GL_TEXTURE_RESIDENT              = 0x8067 ;
const uint GL_TEXTURE_BINDING_1D            = 0x8068 ;
const uint GL_TEXTURE_BINDING_2D            = 0x8069 ;
const uint GL_VERTEX_ARRAY                  = 0x8074 ;
const uint GL_NORMAL_ARRAY                  = 0x8075 ;
const uint GL_COLOR_ARRAY                   = 0x8076 ;
const uint GL_INDEX_ARRAY                   = 0x8077 ;
const uint GL_TEXTURE_COORD_ARRAY           = 0x8078 ;
const uint GL_EDGE_FLAG_ARRAY               = 0x8079 ;
const uint GL_VERTEX_ARRAY_SIZE             = 0x807A ;
const uint GL_VERTEX_ARRAY_TYPE             = 0x807B ;
const uint GL_VERTEX_ARRAY_STRIDE           = 0x807C ;
const uint GL_NORMAL_ARRAY_TYPE             = 0x807E ;
const uint GL_NORMAL_ARRAY_STRIDE           = 0x807F ;
const uint GL_COLOR_ARRAY_SIZE              = 0x8081 ;
const uint GL_COLOR_ARRAY_TYPE              = 0x8082 ;
const uint GL_COLOR_ARRAY_STRIDE            = 0x8083 ;
const uint GL_INDEX_ARRAY_TYPE              = 0x8085 ;
const uint GL_INDEX_ARRAY_STRIDE            = 0x8086 ;
const uint GL_TEXTURE_COORD_ARRAY_SIZE      = 0x8088 ;
const uint GL_TEXTURE_COORD_ARRAY_TYPE      = 0x8089 ;
const uint GL_TEXTURE_COORD_ARRAY_STRIDE    = 0x808A ;
const uint GL_EDGE_FLAG_ARRAY_STRIDE        = 0x808C ;
const uint GL_VERTEX_ARRAY_POINTER          = 0x808E ;
const uint GL_NORMAL_ARRAY_POINTER          = 0x808F ;
const uint GL_COLOR_ARRAY_POINTER           = 0x8090 ;
const uint GL_INDEX_ARRAY_POINTER           = 0x8091 ;
const uint GL_TEXTURE_COORD_ARRAY_POINTER   = 0x8092 ;
const uint GL_EDGE_FLAG_ARRAY_POINTER       = 0x8093 ;
const uint GL_V2F                           = 0x2A20 ;
const uint GL_V3F                           = 0x2A21 ;
const uint GL_C4UB_V2F                      = 0x2A22 ;
const uint GL_C4UB_V3F                      = 0x2A23 ;
const uint GL_C3F_V3F                       = 0x2A24 ;
const uint GL_N3F_V3F                       = 0x2A25 ;
const uint GL_C4F_N3F_V3F                   = 0x2A26 ;
const uint GL_T2F_V3F                       = 0x2A27 ;
const uint GL_T4F_V4F                       = 0x2A28 ;
const uint GL_T2F_C4UB_V3F                  = 0x2A29 ;
const uint GL_T2F_C3F_V3F                   = 0x2A2A ;
const uint GL_T2F_N3F_V3F                   = 0x2A2B ;
const uint GL_T2F_C4F_N3F_V3F               = 0x2A2C ;
const uint GL_T4F_C4F_N3F_V4F               = 0x2A2D ;
const uint GL_LOGIC_OP                      = GL_INDEX_LOGIC_OP ;
const uint GL_TEXTURE_COMPONENTS            = GL_TEXTURE_INTERNAL_FORMAT ;
const uint GL_COLOR_INDEX1_EXT              = 0x80E2 ;
const uint GL_COLOR_INDEX2_EXT              = 0x80E3 ;
const uint GL_COLOR_INDEX4_EXT              = 0x80E4 ;
const uint GL_COLOR_INDEX8_EXT              = 0x80E5 ;
const uint GL_COLOR_INDEX12_EXT             = 0x80E6 ;
const uint GL_COLOR_INDEX16_EXT             = 0x80E7 ;

extern(Windows) export void      glAccum (GLenum op, GLfloat value);
extern(Windows) export void      glAlphaFunc (GLenum func, GLclampf value);
extern(Windows) export GLboolean glAreTexturesResident (GLsizei n, const GLuint *textures, GLboolean *residences);
extern(Windows) export void      glArrayElement (GLint i);
extern(Windows) export void      glBegin (GLenum mode);
extern(Windows) export void      glBindTexture (GLenum target, GLuint texture);
extern(Windows) export void      glBitmap (GLsizei width, GLsizei height, GLfloat xorig, GLfloat yorig, GLfloat xmove, GLfloat ymove, const GLubyte *bitmap);
extern(Windows) export void      glBlendFunc (GLenum sfactor, GLenum dfactor);
extern(Windows) export void      glCallList (GLuint list);
extern(Windows) export void      glCallLists (GLsizei n, GLenum type, const GLvoid *lists);
extern(Windows) export void      glClear (GLbitfield mask);
extern(Windows) export void      glClearAccum (GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha);
extern(Windows) export void      glClearColor (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
extern(Windows) export void      glClearDepth (GLclampd depth);
extern(Windows) export void      glClearIndex (GLfloat c);
extern(Windows) export void      glClearStencil (GLint s);
extern(Windows) export void      glClipPlane (GLenum plane, const GLdouble *equation);
extern(Windows) export void      glColor3b (GLbyte red, GLbyte green, GLbyte blue);
extern(Windows) export void      glColor3bv (const GLbyte *v);
extern(Windows) export void      glColor3d (GLdouble red, GLdouble green, GLdouble blue);
extern(Windows) export void      glColor3dv (const GLdouble *v);
extern(Windows) export void      glColor3f (GLfloat red, GLfloat green, GLfloat blue);
extern(Windows) export void      glColor3fv (const GLfloat *v);
extern(Windows) export void      glColor3i (GLint red, GLint green, GLint blue);
extern(Windows) export void      glColor3iv (const GLint *v);
extern(Windows) export void      glColor3s (GLshort red, GLshort green, GLshort blue);
extern(Windows) export void      glColor3sv (const GLshort *v);
extern(Windows) export void      glColor3ub (GLubyte red, GLubyte green, GLubyte blue);
extern(Windows) export void      glColor3ubv (const GLubyte *v);
extern(Windows) export void      glColor3ui (GLuint red, GLuint green, GLuint blue);
extern(Windows) export void      glColor3uiv (const GLuint *v);
extern(Windows) export void      glColor3us (GLushort red, GLushort green, GLushort blue);
extern(Windows) export void      glColor3usv (const GLushort *v);
extern(Windows) export void      glColor4b (GLbyte red, GLbyte green, GLbyte blue, GLbyte alpha);
extern(Windows) export void      glColor4bv (const GLbyte *v);
extern(Windows) export void      glColor4d (GLdouble red, GLdouble green, GLdouble blue, GLdouble alpha);
extern(Windows) export void      glColor4dv (const GLdouble *v);
extern(Windows) export void      glColor4f (GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha);
extern(Windows) export void      glColor4fv (const GLfloat *v);
extern(Windows) export void      glColor4i (GLint red, GLint green, GLint blue, GLint alpha);
extern(Windows) export void      glColor4iv (const GLint *v);
extern(Windows) export void      glColor4s (GLshort red, GLshort green, GLshort blue, GLshort alpha);
extern(Windows) export void      glColor4sv (const GLshort *v);
extern(Windows) export void      glColor4ub (GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha);
extern(Windows) export void      glColor4ubv (const GLubyte *v);
extern(Windows) export void      glColor4ui (GLuint red, GLuint green, GLuint blue, GLuint alpha);
extern(Windows) export void      glColor4uiv (const GLuint *v);
extern(Windows) export void      glColor4us (GLushort red, GLushort green, GLushort blue, GLushort alpha);
extern(Windows) export void      glColor4usv (const GLushort *v);
extern(Windows) export void      glColorMask (GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha);
extern(Windows) export void      glColorMaterial (GLenum face, GLenum mode);
extern(Windows) export void      glColorPointer (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
extern(Windows) export void      glCopyPixels (GLint x, GLint y, GLsizei width, GLsizei height, GLenum type);
extern(Windows) export void      glCopyTexImage1D (GLenum target, GLint level, GLenum internalFormat, GLint x, GLint y, GLsizei width, GLint border);
extern(Windows) export void      glCopyTexImage2D (GLenum target, GLint level, GLenum internalFormat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border);
extern(Windows) export void      glCopyTexSubImage1D (GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width);
extern(Windows) export void      glCopyTexSubImage2D (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height);
extern(Windows) export void      glCullFace (GLenum mode);
extern(Windows) export void      glDeleteLists (GLuint list, GLsizei range);
extern(Windows) export void      glDeleteTextures (GLsizei n, const GLuint *textures);
extern(Windows) export void      glDepthFunc (GLenum func);
extern(Windows) export void      glDepthMask (GLboolean flag);
extern(Windows) export void      glDepthRange (GLclampd zNear, GLclampd zFar);
extern(Windows) export void      glDisable (GLenum cap);
extern(Windows) export void      glDisableClientState (GLenum array);
extern(Windows) export void      glDrawArrays (GLenum mode, GLint first, GLsizei count);
extern(Windows) export void      glDrawBuffer (GLenum mode);
extern(Windows) export void      glDrawElements (GLenum mode, GLsizei count, GLenum type, const GLvoid *indices);
extern(Windows) export void      glDrawPixels (GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels);
extern(Windows) export void      glEdgeFlag (GLboolean flag);
extern(Windows) export void      glEdgeFlagPointer (GLsizei stride, const GLvoid *pointer);
extern(Windows) export void      glEdgeFlagv (const GLboolean *flag);
extern(Windows) export void      glEnable (GLenum cap);
extern(Windows) export void      glEnableClientState (GLenum array);
extern(Windows) export void      glEnd ();
extern(Windows) export void      glEndList ();
extern(Windows) export void      glEvalCoord1d (GLdouble u);
extern(Windows) export void      glEvalCoord1dv (const GLdouble *u);
extern(Windows) export void      glEvalCoord1f (GLfloat u);
extern(Windows) export void      glEvalCoord1fv (const GLfloat *u);
extern(Windows) export void      glEvalCoord2d (GLdouble u, GLdouble v);
extern(Windows) export void      glEvalCoord2dv (const GLdouble *u);
extern(Windows) export void      glEvalCoord2f (GLfloat u, GLfloat v);
extern(Windows) export void      glEvalCoord2fv (const GLfloat *u);
extern(Windows) export void      glEvalMesh1 (GLenum mode, GLint i1, GLint i2);
extern(Windows) export void      glEvalMesh2 (GLenum mode, GLint i1, GLint i2, GLint j1, GLint j2);
extern(Windows) export void      glEvalPoint1 (GLint i);
extern(Windows) export void      glEvalPoint2 (GLint i, GLint j);
extern(Windows) export void      glFeedbackBuffer (GLsizei size, GLenum type, GLfloat *buffer);
extern(Windows) export void      glFinish ();
extern(Windows) export void      glFlush ();
extern(Windows) export void      glFogf (GLenum pname, GLfloat param);
extern(Windows) export void      glFogfv (GLenum pname, const GLfloat *params);
extern(Windows) export void      glFogi (GLenum pname, GLint param);
extern(Windows) export void      glFogiv (GLenum pname, const GLint *params);
extern(Windows) export void      glFrontFace (GLenum mode);
extern(Windows) export void      glFrustum (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
extern(Windows) export GLuint    glGenLists (GLsizei range);
extern(Windows) export void      glGenTextures (GLsizei n, GLuint *textures);
extern(Windows) export void      glGetBooleanv (GLenum pname, GLboolean *params);
extern(Windows) export void      glGetClipPlane (GLenum plane, GLdouble *equation);
extern(Windows) export void      glGetDoublev (GLenum pname, GLdouble *params);
extern(Windows) export GLenum    glGetError ();
extern(Windows) export void      glGetFloatv (GLenum pname, GLfloat *params);
extern(Windows) export void      glGetIntegerv (GLenum pname, GLint *params);
extern(Windows) export void      glGetLightfv (GLenum light, GLenum pname, GLfloat *params);
extern(Windows) export void      glGetLightiv (GLenum light, GLenum pname, GLint *params);
extern(Windows) export void      glGetMapdv (GLenum target, GLenum query, GLdouble *v);
extern(Windows) export void      glGetMapfv (GLenum target, GLenum query, GLfloat *v);
extern(Windows) export void      glGetMapiv (GLenum target, GLenum query, GLint *v);
extern(Windows) export void      glGetMaterialfv (GLenum face, GLenum pname, GLfloat *params);
extern(Windows) export void      glGetMaterialiv (GLenum face, GLenum pname, GLint *params);
extern(Windows) export void      glGetPixelMapfv (GLenum map, GLfloat *values);
extern(Windows) export void      glGetPixelMapuiv (GLenum map, GLuint *values);
extern(Windows) export void      glGetPixelMapusv (GLenum map, GLushort *values);
extern(Windows) export void      glGetPointerv (GLenum pname, GLvoid* *params);
extern(Windows) export void      glGetPolygonStipple (GLubyte *mask);
extern(Windows) export GLubyte*  glGetString (GLenum name);
extern(Windows) export void      glGetTexEnvfv (GLenum target, GLenum pname, GLfloat *params);
extern(Windows) export void      glGetTexEnviv (GLenum target, GLenum pname, GLint *params);
extern(Windows) export void      glGetTexGendv (GLenum coord, GLenum pname, GLdouble *params);
extern(Windows) export void      glGetTexGenfv (GLenum coord, GLenum pname, GLfloat *params);
extern(Windows) export void      glGetTexGeniv (GLenum coord, GLenum pname, GLint *params);
extern(Windows) export void      glGetTexImage (GLenum target, GLint level, GLenum format, GLenum type, GLvoid *pixels);
extern(Windows) export void      glGetTexLevelParameterfv (GLenum target, GLint level, GLenum pname, GLfloat *params);
extern(Windows) export void      glGetTexLevelParameteriv (GLenum target, GLint level, GLenum pname, GLint *params);
extern(Windows) export void      glGetTexParameterfv (GLenum target, GLenum pname, GLfloat *params);
extern(Windows) export void      glGetTexParameteriv (GLenum target, GLenum pname, GLint *params);
extern(Windows) export void      glHint (GLenum target, GLenum mode);
extern(Windows) export void      glIndexMask (GLuint mask);
extern(Windows) export void      glIndexPointer (GLenum type, GLsizei stride, const GLvoid *pointer);
extern(Windows) export void      glIndexd (GLdouble c);
extern(Windows) export void      glIndexdv (const GLdouble *c);
extern(Windows) export void      glIndexf (GLfloat c);
extern(Windows) export void      glIndexfv (const GLfloat *c);
extern(Windows) export void      glIndexi (GLint c);
extern(Windows) export void      glIndexiv (const GLint *c);
extern(Windows) export void      glIndexs (GLshort c);
extern(Windows) export void      glIndexsv (const GLshort *c);
extern(Windows) export void      glIndexub (GLubyte c);
extern(Windows) export void      glIndexubv (const GLubyte *c);
extern(Windows) export void      glInitNames ();
extern(Windows) export void      glInterleavedArrays (GLenum format, GLsizei stride, const GLvoid *pointer);
extern(Windows) export GLboolean glIsEnabled (GLenum cap);
extern(Windows) export GLboolean glIsList (GLuint list);
extern(Windows) export GLboolean glIsTexture (GLuint texture);
extern(Windows) export void      glLightModelf (GLenum pname, GLfloat param);
extern(Windows) export void      glLightModelfv (GLenum pname, const GLfloat *params);
extern(Windows) export void      glLightModeli (GLenum pname, GLint param);
extern(Windows) export void      glLightModeliv (GLenum pname, const GLint *params);
extern(Windows) export void      glLightf (GLenum light, GLenum pname, GLfloat param);
extern(Windows) export void      glLightfv (GLenum light, GLenum pname, const GLfloat *params);
extern(Windows) export void      glLighti (GLenum light, GLenum pname, GLint param);
extern(Windows) export void      glLightiv (GLenum light, GLenum pname, const GLint *params);
extern(Windows) export void      glLineStipple (GLint factor, GLushort pattern);
extern(Windows) export void      glLineWidth (GLfloat width);
extern(Windows) export void      glListBase (GLuint base);
extern(Windows) export void      glLoadIdentity ();
extern(Windows) export void      glLoadMatrixd (const GLdouble *m);
extern(Windows) export void      glLoadMatrixf (const GLfloat *m);
extern(Windows) export void      glLoadName (GLuint name);
extern(Windows) export void      glLogicOp (GLenum opcode);
extern(Windows) export void      glMap1d (GLenum target, GLdouble u1, GLdouble u2, GLint stride, GLint order, const GLdouble *points);
extern(Windows) export void      glMap1f (GLenum target, GLfloat u1, GLfloat u2, GLint stride, GLint order, const GLfloat *points);
extern(Windows) export void      glMap2d (GLenum target, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, const GLdouble *points);
extern(Windows) export void      glMap2f (GLenum target, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, const GLfloat *points);
extern(Windows) export void      glMapGrid1d (GLint un, GLdouble u1, GLdouble u2);
extern(Windows) export void      glMapGrid1f (GLint un, GLfloat u1, GLfloat u2);
extern(Windows) export void      glMapGrid2d (GLint un, GLdouble u1, GLdouble u2, GLint vn, GLdouble v1, GLdouble v2);
extern(Windows) export void      glMapGrid2f (GLint un, GLfloat u1, GLfloat u2, GLint vn, GLfloat v1, GLfloat v2);
extern(Windows) export void      glMaterialf (GLenum face, GLenum pname, GLfloat param);
extern(Windows) export void      glMaterialfv (GLenum face, GLenum pname, const GLfloat *params);
extern(Windows) export void      glMateriali (GLenum face, GLenum pname, GLint param);
extern(Windows) export void      glMaterialiv (GLenum face, GLenum pname, const GLint *params);
extern(Windows) export void      glMatrixMode (GLenum mode);
extern(Windows) export void      glMultMatrixd (const GLdouble *m);
extern(Windows) export void      glMultMatrixf (const GLfloat *m);
extern(Windows) export void      glNewList (GLuint list, GLenum mode);
extern(Windows) export void      glNormal3b (GLbyte nx, GLbyte ny, GLbyte nz);
extern(Windows) export void      glNormal3bv (const GLbyte *v);
extern(Windows) export void      glNormal3d (GLdouble nx, GLdouble ny, GLdouble nz);
extern(Windows) export void      glNormal3dv (const GLdouble *v);
extern(Windows) export void      glNormal3f (GLfloat nx, GLfloat ny, GLfloat nz);
extern(Windows) export void      glNormal3fv (const GLfloat *v);
extern(Windows) export void      glNormal3i (GLint nx, GLint ny, GLint nz);
extern(Windows) export void      glNormal3iv (const GLint *v);
extern(Windows) export void      glNormal3s (GLshort nx, GLshort ny, GLshort nz);
extern(Windows) export void      glNormal3sv (const GLshort *v);
extern(Windows) export void      glNormalPointer (GLenum type, GLsizei stride, const GLvoid *pointer);
extern(Windows) export void      glOrtho (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
extern(Windows) export void      glPassThrough (GLfloat token);
extern(Windows) export void      glPixelMapfv (GLenum map, GLsizei mapsize, const GLfloat *values);
extern(Windows) export void      glPixelMapuiv (GLenum map, GLsizei mapsize, const GLuint *values);
extern(Windows) export void      glPixelMapusv (GLenum map, GLsizei mapsize, const GLushort *values);
extern(Windows) export void      glPixelStoref (GLenum pname, GLfloat param);
extern(Windows) export void      glPixelStorei (GLenum pname, GLint param);
extern(Windows) export void      glPixelTransferf (GLenum pname, GLfloat param);
extern(Windows) export void      glPixelTransferi (GLenum pname, GLint param);
extern(Windows) export void      glPixelZoom (GLfloat xfactor, GLfloat yfactor);
extern(Windows) export void      glPointSize (GLfloat size);
extern(Windows) export void      glPolygonMode (GLenum face, GLenum mode);
extern(Windows) export void      glPolygonOffset (GLfloat factor, GLfloat units);
extern(Windows) export void      glPolygonStipple (const GLubyte *mask);
extern(Windows) export void      glPopAttrib ();
extern(Windows) export void      glPopClientAttrib ();
extern(Windows) export void      glPopMatrix ();
extern(Windows) export void      glPopName ();
extern(Windows) export void      glPrioritizeTextures (GLsizei n, const GLuint *textures, const GLclampf *priorities);
extern(Windows) export void      glPushAttrib (GLbitfield mask);
extern(Windows) export void      glPushClientAttrib (GLbitfield mask);
extern(Windows) export void      glPushMatrix ();
extern(Windows) export void      glPushName (GLuint name);
extern(Windows) export void      glRasterPos2d (GLdouble x, GLdouble y);
extern(Windows) export void      glRasterPos2dv (const GLdouble *v);
extern(Windows) export void      glRasterPos2f (GLfloat x, GLfloat y);
extern(Windows) export void      glRasterPos2fv (const GLfloat *v);
extern(Windows) export void      glRasterPos2i (GLint x, GLint y);
extern(Windows) export void      glRasterPos2iv (const GLint *v);
extern(Windows) export void      glRasterPos2s (GLshort x, GLshort y);
extern(Windows) export void      glRasterPos2sv (const GLshort *v);
extern(Windows) export void      glRasterPos3d (GLdouble x, GLdouble y, GLdouble z);
extern(Windows) export void      glRasterPos3dv (const GLdouble *v);
extern(Windows) export void      glRasterPos3f (GLfloat x, GLfloat y, GLfloat z);
extern(Windows) export void      glRasterPos3fv (const GLfloat *v);
extern(Windows) export void      glRasterPos3i (GLint x, GLint y, GLint z);
extern(Windows) export void      glRasterPos3iv (const GLint *v);
extern(Windows) export void      glRasterPos3s (GLshort x, GLshort y, GLshort z);
extern(Windows) export void      glRasterPos3sv (const GLshort *v);
extern(Windows) export void      glRasterPos4d (GLdouble x, GLdouble y, GLdouble z, GLdouble w);
extern(Windows) export void      glRasterPos4dv (const GLdouble *v);
extern(Windows) export void      glRasterPos4f (GLfloat x, GLfloat y, GLfloat z, GLfloat w);
extern(Windows) export void      glRasterPos4fv (const GLfloat *v);
extern(Windows) export void      glRasterPos4i (GLint x, GLint y, GLint z, GLint w);
extern(Windows) export void      glRasterPos4iv (const GLint *v);
extern(Windows) export void      glRasterPos4s (GLshort x, GLshort y, GLshort z, GLshort w);
extern(Windows) export void      glRasterPos4sv (const GLshort *v);
extern(Windows) export void      glReadBuffer (GLenum mode);
extern(Windows) export void      glReadPixels (GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *pixels);
extern(Windows) export void      glRectd (GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2);
extern(Windows) export void      glRectdv (const GLdouble *v1, const GLdouble *v2);
extern(Windows) export void      glRectf (GLfloat x1, GLfloat y1, GLfloat x2, GLfloat y2);
extern(Windows) export void      glRectfv (const GLfloat *v1, const GLfloat *v2);
extern(Windows) export void      glRecti (GLint x1, GLint y1, GLint x2, GLint y2);
extern(Windows) export void      glRectiv (const GLint *v1, const GLint *v2);
extern(Windows) export void      glRects (GLshort x1, GLshort y1, GLshort x2, GLshort y2);
extern(Windows) export void      glRectsv (const GLshort *v1, const GLshort *v2);
extern(Windows) export GLint     glRenderMode (GLenum mode);
extern(Windows) export void      glRotated (GLdouble angle, GLdouble x, GLdouble y, GLdouble z);
extern(Windows) export void      glRotatef (GLfloat angle, GLfloat x, GLfloat y, GLfloat z);
extern(Windows) export void      glScaled (GLdouble x, GLdouble y, GLdouble z);
extern(Windows) export void      glScalef (GLfloat x, GLfloat y, GLfloat z);
extern(Windows) export void      glScissor (GLint x, GLint y, GLsizei width, GLsizei height);
extern(Windows) export void      glSelectBuffer (GLsizei size, GLuint *buffer);
extern(Windows) export void      glShadeModel (GLenum mode);
extern(Windows) export void      glStencilFunc (GLenum func, GLint value, GLuint mask);
extern(Windows) export void      glStencilMask (GLuint mask);
extern(Windows) export void      glStencilOp (GLenum fail, GLenum zfail, GLenum zpass);
extern(Windows) export void      glTexCoord1d (GLdouble s);
extern(Windows) export void      glTexCoord1dv (const GLdouble *v);
extern(Windows) export void      glTexCoord1f (GLfloat s);
extern(Windows) export void      glTexCoord1fv (const GLfloat *v);
extern(Windows) export void      glTexCoord1i (GLint s);
extern(Windows) export void      glTexCoord1iv (const GLint *v);
extern(Windows) export void      glTexCoord1s (GLshort s);
extern(Windows) export void      glTexCoord1sv (const GLshort *v);
extern(Windows) export void      glTexCoord2d (GLdouble s, GLdouble t);
extern(Windows) export void      glTexCoord2dv (const GLdouble *v);
extern(Windows) export void      glTexCoord2f (GLfloat s, GLfloat t);
extern(Windows) export void      glTexCoord2fv (const GLfloat *v);
extern(Windows) export void      glTexCoord2i (GLint s, GLint t);
extern(Windows) export void      glTexCoord2iv (const GLint *v);
extern(Windows) export void      glTexCoord2s (GLshort s, GLshort t);
extern(Windows) export void      glTexCoord2sv (const GLshort *v);
extern(Windows) export void      glTexCoord3d (GLdouble s, GLdouble t, GLdouble r);
extern(Windows) export void      glTexCoord3dv (const GLdouble *v);
extern(Windows) export void      glTexCoord3f (GLfloat s, GLfloat t, GLfloat r);
extern(Windows) export void      glTexCoord3fv (const GLfloat *v);
extern(Windows) export void      glTexCoord3i (GLint s, GLint t, GLint r);
extern(Windows) export void      glTexCoord3iv (const GLint *v);
extern(Windows) export void      glTexCoord3s (GLshort s, GLshort t, GLshort r);
extern(Windows) export void      glTexCoord3sv (const GLshort *v);
extern(Windows) export void      glTexCoord4d (GLdouble s, GLdouble t, GLdouble r, GLdouble q);
extern(Windows) export void      glTexCoord4dv (const GLdouble *v);
extern(Windows) export void      glTexCoord4f (GLfloat s, GLfloat t, GLfloat r, GLfloat q);
extern(Windows) export void      glTexCoord4fv (const GLfloat *v);
extern(Windows) export void      glTexCoord4i (GLint s, GLint t, GLint r, GLint q);
extern(Windows) export void      glTexCoord4iv (const GLint *v);
extern(Windows) export void      glTexCoord4s (GLshort s, GLshort t, GLshort r, GLshort q);
extern(Windows) export void      glTexCoord4sv (const GLshort *v);
extern(Windows) export void      glTexCoordPointer (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
extern(Windows) export void      glTexEnvf (GLenum target, GLenum pname, GLfloat param);
extern(Windows) export void      glTexEnvfv (GLenum target, GLenum pname, const GLfloat *params);
extern(Windows) export void      glTexEnvi (GLenum target, GLenum pname, GLint param);
extern(Windows) export void      glTexEnviv (GLenum target, GLenum pname, const GLint *params);
extern(Windows) export void      glTexGend (GLenum coord, GLenum pname, GLdouble param);
extern(Windows) export void      glTexGendv (GLenum coord, GLenum pname, const GLdouble *params);
extern(Windows) export void      glTexGenf (GLenum coord, GLenum pname, GLfloat param);
extern(Windows) export void      glTexGenfv (GLenum coord, GLenum pname, const GLfloat *params);
extern(Windows) export void      glTexGeni (GLenum coord, GLenum pname, GLint param);
extern(Windows) export void      glTexGeniv (GLenum coord, GLenum pname, const GLint *params);
extern(Windows) export void      glTexImage1D (GLenum target, GLint level, GLint internalformat, GLsizei width, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
extern(Windows) export void      glTexImage2D (GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
extern(Windows) export void      glTexParameterf (GLenum target, GLenum pname, GLfloat param);
extern(Windows) export void      glTexParameterfv (GLenum target, GLenum pname, const GLfloat *params);
extern(Windows) export void      glTexParameteri (GLenum target, GLenum pname, GLint param);
extern(Windows) export void      glTexParameteriv (GLenum target, GLenum pname, const GLint *params);
extern(Windows) export void      glTexSubImage1D (GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const GLvoid *pixels);
extern(Windows) export void      glTexSubImage2D (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels);
extern(Windows) export void      glTranslated (GLdouble x, GLdouble y, GLdouble z);
extern(Windows) export void      glTranslatef (GLfloat x, GLfloat y, GLfloat z);
extern(Windows) export void      glVertex2d (GLdouble x, GLdouble y);
extern(Windows) export void      glVertex2dv (const GLdouble *v);
extern(Windows) export void      glVertex2f (GLfloat x, GLfloat y);
extern(Windows) export void      glVertex2fv (const GLfloat *v);
extern(Windows) export void      glVertex2i (GLint x, GLint y);
extern(Windows) export void      glVertex2iv (const GLint *v);
extern(Windows) export void      glVertex2s (GLshort x, GLshort y);
extern(Windows) export void      glVertex2sv (const GLshort *v);
extern(Windows) export void      glVertex3d (GLdouble x, GLdouble y, GLdouble z);
extern(Windows) export void      glVertex3dv (const GLdouble *v);
extern(Windows) export void      glVertex3f (GLfloat x, GLfloat y, GLfloat z);
extern(Windows) export void      glVertex3fv (const GLfloat *v);
extern(Windows) export void      glVertex3i (GLint x, GLint y, GLint z);
extern(Windows) export void      glVertex3iv (const GLint *v);
extern(Windows) export void      glVertex3s (GLshort x, GLshort y, GLshort z);
extern(Windows) export void      glVertex3sv (const GLshort *v);
extern(Windows) export void      glVertex4d (GLdouble x, GLdouble y, GLdouble z, GLdouble w);
extern(Windows) export void      glVertex4dv (const GLdouble *v);
extern(Windows) export void      glVertex4f (GLfloat x, GLfloat y, GLfloat z, GLfloat w);
extern(Windows) export void      glVertex4fv (const GLfloat *v);
extern(Windows) export void      glVertex4i (GLint x, GLint y, GLint z, GLint w);
extern(Windows) export void      glVertex4iv (const GLint *v);
extern(Windows) export void      glVertex4s (GLshort x, GLshort y, GLshort z, GLshort w);
extern(Windows) export void      glVertex4sv (const GLshort *v);
extern(Windows) export void      glVertexPointer (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
extern(Windows) export void      glViewport (GLint x, GLint y, GLsizei width, GLsizei height);

extern (C) struct GLUnurbs { }
extern (C) struct GLUquadric { }
extern (C) struct GLUtesselator { }
alias GLUnurbs      GLUnurbsObj;
alias GLUquadric    GLUquadricObj;
alias GLUtesselator GLUtesselatorObj;
alias GLUtesselator GLUtriangulatorObj;

const GLUT_STROKE_ROMAN               =0;
const GLUT_STROKE_MONO_ROMAN          =1;
const GLUT_BITMAP_9_BY_15             =2;
const GLUT_BITMAP_8_BY_13             =3;
const GLUT_BITMAP_TIMES_ROMAN_10      =4;
const GLUT_BITMAP_TIMES_ROMAN_24      =5;
const GLUT_BITMAP_HELVETICA_10        =6;
const GLUT_BITMAP_HELVETICA_12        =7;
const GLUT_BITMAP_HELVETICA_18        =8;

extern(Windows) export void    gluBeginCurve (GLUnurbs* nurb) ;
extern(Windows) export void    gluBeginPolygon (GLUtesselator* tess) ;
extern(Windows) export void    gluBeginSurface (GLUnurbs* nurb) ;
extern(Windows) export void    gluBeginTrim (GLUnurbs* nurb) ;
extern(Windows) export GLint   gluBuild1DMipmaps (GLenum target, GLint internalFormat, GLsizei width, GLenum format, GLenum type, void *data) ;
extern(Windows) export GLint   gluBuild2DMipmaps (GLenum target, GLint internalFormat, GLsizei width, GLsizei height, GLenum format, GLenum type, void *data) ;
extern(Windows) export void    gluCylinder (GLUquadric* quad, GLdouble base, GLdouble top, GLdouble height, GLint slices, GLint stacks) ;
extern(Windows) export void    gluDeleteNurbsRenderer (GLUnurbs* nurb) ;
extern(Windows) export void    gluDeleteQuadric (GLUquadric* quad) ;
extern(Windows) export void    gluDeleteTess (GLUtesselator* tess) ;
extern(Windows) export void    gluDisk (GLUquadric* quad, GLdouble inner, GLdouble outer, GLint slices, GLint loops) ;
extern(Windows) export void    gluEndCurve (GLUnurbs* nurb) ;
extern(Windows) export void    gluEndPolygon (GLUtesselator* tess) ;
extern(Windows) export void    gluEndSurface (GLUnurbs* nurb) ;
extern(Windows) export void    gluEndTrim (GLUnurbs* nurb) ;
extern(Windows) export GLubyte*  gluErrorString (GLenum error) ;
extern(Windows) export wchar*    gluErrorUnicodeStringEXT (GLenum error) ;
extern(Windows) export void    gluGetNurbsProperty (GLUnurbs* nurb, GLenum property, GLfloat* data) ;
extern(Windows) export GLubyte *  gluGetString (GLenum name) ;
extern(Windows) export void    gluGetTessProperty (GLUtesselator* tess, GLenum which, GLdouble* data) ;
extern(Windows) export void    gluLoadSamplingMatrices (GLUnurbs* nurb, GLfloat *model, GLfloat *perspective, GLint *view) ;
extern(Windows) export void    gluLookAt (GLdouble eyeX, GLdouble eyeY, GLdouble eyeZ, GLdouble centerX, GLdouble centerY, GLdouble centerZ, GLdouble upX, GLdouble upY, GLdouble upZ) ;
extern(Windows) export GLUnurbs*  gluNewNurbsRenderer () ;
extern(Windows) export GLUquadric*  gluNewQuadric () ;
extern(Windows) export GLUtesselator*  gluNewTess () ;
extern(Windows) export void    gluNextContour (GLUtesselator* tess, GLenum type) ;
extern(Windows) export void    gluNurbsCallback (GLUnurbs* nurb, GLenum which, void function()) ;
extern(Windows) export void    gluNurbsCurve (GLUnurbs* nurb, GLint knotCount, GLfloat *knots, GLint stride, GLfloat *control, GLint order, GLenum type) ;
extern(Windows) export void    gluNurbsProperty (GLUnurbs* nurb, GLenum property, GLfloat value) ;
extern(Windows) export void    gluNurbsSurface (GLUnurbs* nurb, GLint sKnotCount, GLfloat* sKnots, GLint tKnotCount, GLfloat* tKnots, GLint sStride, GLint tStride, GLfloat* control, GLint sOrder, GLint tOrder, GLenum type) ;
extern(Windows) export void    gluOrtho2D (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top) ;
extern(Windows) export void    gluPartialDisk (GLUquadric* quad, GLdouble inner, GLdouble outer, GLint slices, GLint loops, GLdouble start, GLdouble sweep) ;
extern(Windows) export void    gluPerspective (GLdouble fovy, GLdouble aspect, GLdouble zNear, GLdouble zFar) ;
extern(Windows) export void    gluPickMatrix (GLdouble x, GLdouble y, GLdouble delX, GLdouble delY, GLint *viewport) ;
extern(Windows) export GLint   gluProject (GLdouble objX, GLdouble objY, GLdouble objZ, GLdouble *model, GLdouble *proj, GLint *view, GLdouble* winX, GLdouble* winY, GLdouble* winZ) ;
extern(Windows) export void    gluPwlCurve (GLUnurbs* nurb, GLint count, GLfloat* data, GLint stride, GLenum type) ;
extern(Windows) export void    gluQuadricCallback (GLUquadric* quad, GLenum which, void function()) ;
extern(Windows) export void    gluQuadricDrawStyle (GLUquadric* quad, GLenum draw) ;
extern(Windows) export void    gluQuadricNormals (GLUquadric* quad, GLenum normal) ;
extern(Windows) export void    gluQuadricOrientation (GLUquadric* quad, GLenum orientation) ;
extern(Windows) export void    gluQuadricTexture (GLUquadric* quad, GLboolean texture) ;
extern(Windows) export GLint   gluScaleImage (GLenum format, GLsizei wIn, GLsizei hIn, GLenum typeIn, void *dataIn, GLsizei wOut, GLsizei hOut, GLenum typeOut, GLvoid* dataOut) ;
extern(Windows) export void    gluSphere (GLUquadric* quad, GLdouble radius, GLint slices, GLint stacks) ;
extern(Windows) export void    gluTessBeginContour (GLUtesselator* tess) ;
extern(Windows) export void    gluTessBeginPolygon (GLUtesselator* tess, GLvoid* data) ;
extern(Windows) export void    gluTessCallback (GLUtesselator* tess, GLenum which, void function()) ;
extern(Windows) export void    gluTessEndContour (GLUtesselator* tess) ;
extern(Windows) export void    gluTessEndPolygon (GLUtesselator* tess) ;
extern(Windows) export void    gluTessNormal (GLUtesselator* tess, GLdouble valueX, GLdouble valueY, GLdouble valueZ) ;
extern(Windows) export void    gluTessProperty (GLUtesselator* tess, GLenum which, GLdouble data) ;
extern(Windows) export void    gluTessVertex (GLUtesselator* tess, GLdouble *location, GLvoid* data) ;
extern(Windows) export GLint   gluUnProject (GLdouble winX, GLdouble winY, GLdouble winZ, GLdouble *model, GLdouble *proj, GLint *view, GLdouble* objX, GLdouble* objY, GLdouble* objZ) ;
extern(Windows) export void    glutInit(int *argcp, char **argv) ;
extern(Windows) export void    glutInitDisplayMode(uint mode) ;
extern(Windows) export void    glutInitDisplayString(char *string) ;
extern(Windows) export void    glutInitWindowPosition(int x, int y) ;
extern(Windows) export void    glutInitWindowSize(int width, int height) ;
extern(Windows) export void    glutMainLoop() ;
extern(Windows) export int     glutCreateWindow(char *title) ;
extern(Windows) export int     glutCreateSubWindow(int win, int x, int y, int width, int height) ;
extern(Windows) export void    glutDestroyWindow(int win) ;
extern(Windows) export void    glutPostRedisplay() ;
extern(Windows) export void    glutPostWindowRedisplay(int win) ;
extern(Windows) export void    glutSwapBuffers() ;
extern(Windows) export int     glutGetWindow() ;
extern(Windows) export void    glutSetWindow(int win) ;
extern(Windows) export void    glutSetWindowTitle(char *title) ;
extern(Windows) export void    glutSetIconTitle(char *title) ;
extern(Windows) export void    glutPositionWindow(int x, int y) ;
extern(Windows) export void    glutReshapeWindow(int width, int height) ;
extern(Windows) export void    glutPopWindow() ;
extern(Windows) export void    glutPushWindow() ;
extern(Windows) export void    glutIconifyWindow() ;
extern(Windows) export void    glutShowWindow() ;
extern(Windows) export void    glutHideWindow() ;
extern(Windows) export void    glutFullScreen() ;
extern(Windows) export void    glutSetCursor(int cursor) ;
extern(Windows) export void    glutWarpPointer(int x, int y) ;
extern(Windows) export void    glutEstablishOverlay() ;
extern(Windows) export void    glutRemoveOverlay() ;
extern(Windows) export void    glutUseLayer(GLenum layer) ;
extern(Windows) export void    glutPostOverlayRedisplay() ;
extern(Windows) export void    glutPostWindowOverlayRedisplay(int win) ;
extern(Windows) export void    glutShowOverlay() ;
extern(Windows) export void    glutHideOverlay() ;
extern(Windows) export int     glutCreateMenu(void  function(int)) ;
extern(Windows) export void    glutDestroyMenu(int menu) ;
extern(Windows) export int     glutGetMenu() ;
extern(Windows) export void    glutSetMenu(int menu) ;
extern(Windows) export void    glutAddMenuEntry(char *label, int value) ;
extern(Windows) export void    glutAddSubMenu(char *label, int submenu) ;
extern(Windows) export void    glutChangeToMenuEntry(int item, char *label, int value) ;
extern(Windows) export void    glutChangeToSubMenu(int item, char *label, int submenu) ;
extern(Windows) export void    glutRemoveMenuItem(int item) ;
extern(Windows) export void    glutAttachMenu(int button) ;
extern(Windows) export void    glutDetachMenu(int button) ;
extern(Windows) export void    glutDisplayFunc(void  function()) ;
extern(Windows) export void    glutReshapeFunc(void  function(int width, int height)) ;
extern(Windows) export void    glutKeyboardFunc(void  function(uchar key, int x, int y)) ;
extern(Windows) export void    glutMouseFunc(void  function(int button, int state, int x, int y)) ;
extern(Windows) export void    glutMotionFunc(void  function(int x, int y)) ;
extern(Windows) export void    glutPassiveMotionFunc(void  function(int x, int y)) ;
extern(Windows) export void    glutEntryFunc(void  function(int state)) ;
extern(Windows) export void    glutVisibilityFunc(void  function(int state)) ;
extern(Windows) export void    glutIdleFunc(void  function()) ;
extern(Windows) export void    glutTimerFunc(uint millis, void  function(int value), int value) ;
extern(Windows) export void    glutMenuStateFunc(void  function(int state)) ;
extern(Windows) export void    glutSpecialFunc(void  function(int key, int x, int y)) ;
extern(Windows) export void    glutSpaceballMotionFunc(void  function(int x, int y, int z)) ;
extern(Windows) export void    glutSpaceballRotateFunc(void  function(int x, int y, int z)) ;
extern(Windows) export void    glutSpaceballButtonFunc(void  function(int button, int state)) ;
extern(Windows) export void    glutButtonBoxFunc(void  function(int button, int state)) ;
extern(Windows) export void    glutDialsFunc(void  function(int dial, int value)) ;
extern(Windows) export void    glutTabletMotionFunc(void  function(int x, int y)) ;
extern(Windows) export void    glutTabletButtonFunc(void  function(int button, int state, int x, int y)) ;
extern(Windows) export void    glutMenuStatusFunc(void  function(int status, int x, int y)) ;
extern(Windows) export void    glutOverlayDisplayFunc(void  function()) ;
extern(Windows) export void    glutWindowStatusFunc(void  function(int state)) ;
extern(Windows) export void    glutKeyboardUpFunc(void  function(uchar key, int x, int y)) ;
extern(Windows) export void    glutSpecialUpFunc(void  function(int key, int x, int y)) ;
extern(Windows) export void    glutJoystickFunc(void  function(uint buttonMask, int x, int y, int z), int pollInterval) ;
extern(Windows) export void    glutSetColor(int cell, GLfloat red, GLfloat green, GLfloat blue) ;
extern(Windows) export GLfloat  glutGetColor(int ndx, int component) ;
extern(Windows) export void    glutCopyColormap(int win) ;
extern(Windows) export int     glutGet(GLenum type) ;
extern(Windows) export int     glutDeviceGet(GLenum type) ;
extern(Windows) export int     glutExtensionSupported(char *name) ;
extern(Windows) export int     glutGetModifiers() ;
extern(Windows) export int     glutLayerGet(GLenum type) ;
extern(Windows) export void    glutBitmapCharacter(void *font, int character) ;
extern(Windows) export int     glutBitmapWidth(void *font, int character) ;
extern(Windows) export void    glutStrokeCharacter(void *font, int character) ;
extern(Windows) export int     glutStrokeWidth(void *font, int character) ;
extern(Windows) export int     glutBitmapLength(void *font, uchar *string) ;
extern(Windows) export int     glutStrokeLength(void *font, uchar *string) ;
extern(Windows) export void    glutWireSphere(GLdouble radius, GLint slices, GLint stacks) ;
extern(Windows) export void    glutSolidSphere(GLdouble radius, GLint slices, GLint stacks) ;
extern(Windows) export void    glutWireCone(GLdouble base, GLdouble height, GLint slices, GLint stacks) ;
extern(Windows) export void    glutSolidCone(GLdouble base, GLdouble height, GLint slices, GLint stacks) ;
extern(Windows) export void    glutWireCube(GLdouble size) ;
extern(Windows) export void    glutSolidCube(GLdouble size) ;
extern(Windows) export void    glutWireTorus(GLdouble innerRadius, GLdouble outerRadius, GLint sides, GLint rings) ;
extern(Windows) export void    glutSolidTorus(GLdouble innerRadius, GLdouble outerRadius, GLint sides, GLint rings) ;
extern(Windows) export void    glutWireDodecahedron() ;
extern(Windows) export void    glutSolidDodecahedron() ;
extern(Windows) export void    glutWireTeapot(GLdouble size) ;
extern(Windows) export void    glutSolidTeapot(GLdouble size) ;
extern(Windows) export void    glutWireOctahedron() ;
extern(Windows) export void    glutSolidOctahedron() ;
extern(Windows) export void    glutWireTetrahedron() ;
extern(Windows) export void    glutSolidTetrahedron() ;
extern(Windows) export void    glutWireIcosahedron() ;
extern(Windows) export void    glutSolidIcosahedron() ;
extern(Windows) export int     glutVideoResizeGet(GLenum param) ;
extern(Windows) export void    glutSetupVideoResizing() ;
extern(Windows) export void    glutStopVideoResizing() ;
extern(Windows) export void    glutVideoResize(int x, int y, int width, int height) ;
extern(Windows) export void    glutVideoPan(int x, int y, int width, int height) ;
extern(Windows) export void    glutReportErrors() ;
extern(Windows) export void    glutIgnoreKeyRepeat(int ignore) ;
extern(Windows) export void    glutSetKeyRepeat(int repeatMode) ;
extern(Windows) export void    glutForceJoystickFunc() ;
extern(Windows) export void    glutGameModeString(char *string) ;
extern(Windows) export int     glutEnterGameMode() ;
extern(Windows) export void    glutLeaveGameMode() ;
extern(Windows) export int     glutGameModeGet(GLenum mode) ;


/* ----------------------------- GL_ARB_imaging ---------------------------- */
const uint GL_CONSTANT_COLOR                      = 0x8001 ;
const uint GL_ONE_MINUS_CONSTANT_COLOR            = 0x8002 ;
const uint GL_CONSTANT_ALPHA                      = 0x8003 ;
const uint GL_ONE_MINUS_CONSTANT_ALPHA            = 0x8004 ;
const uint GL_BLEND_COLOR                         = 0x8005 ;
const uint GL_FUNC_ADD                            = 0x8006 ;
const uint GL_MIN                                 = 0x8007 ;
const uint GL_MAX                                 = 0x8008 ;
const uint GL_BLEND_EQUATION                      = 0x8009 ;
const uint GL_FUNC_SUBTRACT                       = 0x800A ;
const uint GL_FUNC_REVERSE_SUBTRACT               = 0x800B ;
const uint GL_CONVOLUTION_1D                      = 0x8010 ;
const uint GL_CONVOLUTION_2D                      = 0x8011 ;
const uint GL_SEPARABLE_2D                        = 0x8012 ;
const uint GL_CONVOLUTION_BORDER_MODE             = 0x8013 ;
const uint GL_CONVOLUTION_FILTER_SCALE            = 0x8014 ;
const uint GL_CONVOLUTION_FILTER_BIAS             = 0x8015 ;
const uint GL_REDUCE                              = 0x8016 ;
const uint GL_CONVOLUTION_FORMAT                  = 0x8017 ;
const uint GL_CONVOLUTION_WIDTH                   = 0x8018 ;
const uint GL_CONVOLUTION_HEIGHT                  = 0x8019 ;
const uint GL_MAX_CONVOLUTION_WIDTH               = 0x801A ;
const uint GL_MAX_CONVOLUTION_HEIGHT              = 0x801B ;
const uint GL_POST_CONVOLUTION_RED_SCALE          = 0x801C ;
const uint GL_POST_CONVOLUTION_GREEN_SCALE        = 0x801D ;
const uint GL_POST_CONVOLUTION_BLUE_SCALE         = 0x801E ;
const uint GL_POST_CONVOLUTION_ALPHA_SCALE        = 0x801F ;
const uint GL_POST_CONVOLUTION_RED_BIAS           = 0x8020 ;
const uint GL_POST_CONVOLUTION_GREEN_BIAS         = 0x8021 ;
const uint GL_POST_CONVOLUTION_BLUE_BIAS          = 0x8022 ;
const uint GL_POST_CONVOLUTION_ALPHA_BIAS         = 0x8023 ;
const uint GL_HISTOGRAM                           = 0x8024 ;
const uint GL_PROXY_HISTOGRAM                     = 0x8025 ;
const uint GL_HISTOGRAM_WIDTH                     = 0x8026 ;
const uint GL_HISTOGRAM_FORMAT                    = 0x8027 ;
const uint GL_HISTOGRAM_RED_SIZE                  = 0x8028 ;
const uint GL_HISTOGRAM_GREEN_SIZE                = 0x8029 ;
const uint GL_HISTOGRAM_BLUE_SIZE                 = 0x802A ;
const uint GL_HISTOGRAM_ALPHA_SIZE                = 0x802B ;
const uint GL_HISTOGRAM_LUMINANCE_SIZE            = 0x802C ;
const uint GL_HISTOGRAM_SINK                      = 0x802D ;
const uint GL_MINMAX                              = 0x802E ;
const uint GL_MINMAX_FORMAT                       = 0x802F ;
const uint GL_MINMAX_SINK                         = 0x8030 ;
const uint GL_TABLE_TOO_LARGE                     = 0x8031 ;
const uint GL_COLOR_MATRIX                        = 0x80B1 ;
const uint GL_COLOR_MATRIX_STACK_DEPTH            = 0x80B2 ;
const uint GL_MAX_COLOR_MATRIX_STACK_DEPTH        = 0x80B3 ;
const uint GL_POST_COLOR_MATRIX_RED_SCALE         = 0x80B4 ;
const uint GL_POST_COLOR_MATRIX_GREEN_SCALE       = 0x80B5 ;
const uint GL_POST_COLOR_MATRIX_BLUE_SCALE        = 0x80B6 ;
const uint GL_POST_COLOR_MATRIX_ALPHA_SCALE       = 0x80B7 ;
const uint GL_POST_COLOR_MATRIX_RED_BIAS          = 0x80B8 ;
const uint GL_POST_COLOR_MATRIX_GREEN_BIAS        = 0x80B9 ;
const uint GL_POST_COLOR_MATRIX_BLUE_BIAS         = 0x80BA ;
const uint GL_POST_COLOR_MATRIX_ALPHA_BIAS        = 0x80BB ;
const uint GL_COLOR_TABLE                         = 0x80D0 ;
const uint GL_POST_CONVOLUTION_COLOR_TABLE        = 0x80D1 ;
const uint GL_POST_COLOR_MATRIX_COLOR_TABLE       = 0x80D2 ;
const uint GL_PROXY_COLOR_TABLE                   = 0x80D3 ;
const uint GL_PROXY_POST_CONVOLUTION_COLOR_TABLE  = 0x80D4 ;
const uint GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE = 0x80D5 ;
const uint GL_COLOR_TABLE_SCALE                   = 0x80D6 ;
const uint GL_COLOR_TABLE_BIAS                    = 0x80D7 ;
const uint GL_COLOR_TABLE_FORMAT                  = 0x80D8 ;
const uint GL_COLOR_TABLE_WIDTH                   = 0x80D9 ;
const uint GL_COLOR_TABLE_RED_SIZE                = 0x80DA ;
const uint GL_COLOR_TABLE_GREEN_SIZE              = 0x80DB ;
const uint GL_COLOR_TABLE_BLUE_SIZE               = 0x80DC ;
const uint GL_COLOR_TABLE_ALPHA_SIZE              = 0x80DD ;
const uint GL_COLOR_TABLE_LUMINANCE_SIZE          = 0x80DE ;
const uint GL_COLOR_TABLE_INTENSITY_SIZE          = 0x80DF ;
const uint GL_IGNORE_BORDER                       = 0x8150 ;
const uint GL_CONSTANT_BORDER                     = 0x8151 ;
const uint GL_WRAP_BORDER                         = 0x8152 ;
const uint GL_REPLICATE_BORDER                    = 0x8153 ;
const uint GL_CONVOLUTION_BORDER_COLOR            = 0x8154 ;


/* ----------------------------- GL_VERSION_1_2 ---------------------------- */
const uint GL_SMOOTH_POINT_SIZE_RANGE       = 0x0B12 ;
const uint GL_SMOOTH_POINT_SIZE_GRANULARITY = 0x0B13 ;
const uint GL_SMOOTH_LINE_WIDTH_RANGE       = 0x0B22 ;
const uint GL_SMOOTH_LINE_WIDTH_GRANULARITY = 0x0B23 ;
const uint GL_UNSIGNED_BYTE_3_3_2           = 0x8032 ;
const uint GL_UNSIGNED_SHORT_4_4_4_4        = 0x8033 ;
const uint GL_UNSIGNED_SHORT_5_5_5_1        = 0x8034 ;
const uint GL_UNSIGNED_INT_8_8_8_8          = 0x8035 ;
const uint GL_UNSIGNED_INT_10_10_10_2       = 0x8036 ;
const uint GL_RESCALE_NORMAL                = 0x803A ;
const uint GL_TEXTURE_BINDING_3D            = 0x806A ;
const uint GL_PACK_SKIP_IMAGES              = 0x806B ;
const uint GL_PACK_IMAGE_HEIGHT             = 0x806C ;
const uint GL_UNPACK_SKIP_IMAGES            = 0x806D ;
const uint GL_UNPACK_IMAGE_HEIGHT           = 0x806E ;
const uint GL_TEXTURE_3D                    = 0x806F ;
const uint GL_PROXY_TEXTURE_3D              = 0x8070 ;
const uint GL_TEXTURE_DEPTH                 = 0x8071 ;
const uint GL_TEXTURE_WRAP_R                = 0x8072 ;
const uint GL_MAX_3D_TEXTURE_SIZE           = 0x8073 ;
const uint GL_BGR                           = 0x80E0 ;
const uint GL_BGRA                          = 0x80E1 ;
const uint GL_MAX_ELEMENTS_VERTICES         = 0x80E8 ;
const uint GL_MAX_ELEMENTS_INDICES          = 0x80E9 ;
const uint GL_CLAMP_TO_EDGE                 = 0x812F ;
const uint GL_TEXTURE_MIN_LOD               = 0x813A ;
const uint GL_TEXTURE_MAX_LOD               = 0x813B ;
const uint GL_TEXTURE_BASE_LEVEL            = 0x813C ;
const uint GL_TEXTURE_MAX_LEVEL             = 0x813D ;
const uint GL_LIGHT_MODEL_COLOR_CONTROL     = 0x81F8 ;
const uint GL_SINGLE_COLOR                  = 0x81F9 ;
const uint GL_SEPARATE_SPECULAR_COLOR       = 0x81FA ;
const uint GL_UNSIGNED_BYTE_2_3_3_REV       = 0x8362 ;
const uint GL_UNSIGNED_SHORT_5_6_5          = 0x8363 ;
const uint GL_UNSIGNED_SHORT_5_6_5_REV      = 0x8364 ;
const uint GL_UNSIGNED_SHORT_4_4_4_4_REV    = 0x8365 ;
const uint GL_UNSIGNED_SHORT_1_5_5_5_REV    = 0x8366 ;
const uint GL_UNSIGNED_INT_8_8_8_8_REV      = 0x8367 ;
const uint GL_UNSIGNED_INT_2_10_10_10_REV   = 0x8368 ;
const uint GL_ALIASED_POINT_SIZE_RANGE      = 0x846D ;
const uint GL_ALIASED_LINE_WIDTH_RANGE      = 0x846E ;

extern(Windows){
alias void function(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height) PFNGLCOPYTEXSUBIMAGE3DPROC ;
alias void function(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const GLvoid *indices) PFNGLDRAWRANGEELEMENTSPROC ;
alias void function(GLenum target, GLint level, GLint internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum fmt, GLenum typ, const GLvoid *pixels) PFNGLTEXIMAGE3DPROC ;
alias void function(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum fmt, GLenum typ, const GLvoid *pixels) PFNGLTEXSUBIMAGE3DPROC ;

PFNGLCOPYTEXSUBIMAGE3DPROC glCopyTexSubImage3D ;
PFNGLDRAWRANGEELEMENTSPROC glDrawRangeElements ;
PFNGLTEXIMAGE3DPROC glTexImage3D ;
PFNGLTEXSUBIMAGE3DPROC glTexSubImage3D ;
}

/* ----------------------------- GL_VERSION_1_3 ---------------------------- */
const uint GL_MULTISAMPLE                   = 0x809D ;
const uint GL_SAMPLE_ALPHA_TO_COVERAGE      = 0x809E ;
const uint GL_SAMPLE_ALPHA_TO_ONE           = 0x809F ;
const uint GL_SAMPLE_COVERAGE               = 0x80A0 ;
const uint GL_SAMPLE_BUFFERS                = 0x80A8 ;
const uint GL_SAMPLES                       = 0x80A9 ;
const uint GL_SAMPLE_COVERAGE_VALUE         = 0x80AA ;
const uint GL_SAMPLE_COVERAGE_INVERT        = 0x80AB ;
const uint GL_CLAMP_TO_BORDER               = 0x812D ;
const uint GL_TEXTURE0                      = 0x84C0 ;
const uint GL_TEXTURE1                      = 0x84C1 ;
const uint GL_TEXTURE2                      = 0x84C2 ;
const uint GL_TEXTURE3                      = 0x84C3 ;
const uint GL_TEXTURE4                      = 0x84C4 ;
const uint GL_TEXTURE5                      = 0x84C5 ;
const uint GL_TEXTURE6                      = 0x84C6 ;
const uint GL_TEXTURE7                      = 0x84C7 ;
const uint GL_TEXTURE8                      = 0x84C8 ;
const uint GL_TEXTURE9                      = 0x84C9 ;
const uint GL_TEXTURE10                     = 0x84CA ;
const uint GL_TEXTURE11                     = 0x84CB ;
const uint GL_TEXTURE12                     = 0x84CC ;
const uint GL_TEXTURE13                     = 0x84CD ;
const uint GL_TEXTURE14                     = 0x84CE ;
const uint GL_TEXTURE15                     = 0x84CF ;
const uint GL_TEXTURE16                     = 0x84D0 ;
const uint GL_TEXTURE17                     = 0x84D1 ;
const uint GL_TEXTURE18                     = 0x84D2 ;
const uint GL_TEXTURE19                     = 0x84D3 ;
const uint GL_TEXTURE20                     = 0x84D4 ;
const uint GL_TEXTURE21                     = 0x84D5 ;
const uint GL_TEXTURE22                     = 0x84D6 ;
const uint GL_TEXTURE23                     = 0x84D7 ;
const uint GL_TEXTURE24                     = 0x84D8 ;
const uint GL_TEXTURE25                     = 0x84D9 ;
const uint GL_TEXTURE26                     = 0x84DA ;
const uint GL_TEXTURE27                     = 0x84DB ;
const uint GL_TEXTURE28                     = 0x84DC ;
const uint GL_TEXTURE29                     = 0x84DD ;
const uint GL_TEXTURE30                     = 0x84DE ;
const uint GL_TEXTURE31                     = 0x84DF ;
const uint GL_ACTIVE_TEXTURE                = 0x84E0 ;
const uint GL_CLIENT_ACTIVE_TEXTURE         = 0x84E1 ;
const uint GL_MAX_TEXTURE_UNITS             = 0x84E2 ;
const uint GL_TRANSPOSE_MODELVIEW_MATRIX    = 0x84E3 ;
const uint GL_TRANSPOSE_PROJECTION_MATRIX   = 0x84E4 ;
const uint GL_TRANSPOSE_TEXTURE_MATRIX      = 0x84E5 ;
const uint GL_TRANSPOSE_COLOR_MATRIX        = 0x84E6 ;
const uint GL_SUBTRACT                      = 0x84E7 ;
const uint GL_COMPRESSED_ALPHA              = 0x84E9 ;
const uint GL_COMPRESSED_LUMINANCE          = 0x84EA ;
const uint GL_COMPRESSED_LUMINANCE_ALPHA    = 0x84EB ;
const uint GL_COMPRESSED_INTENSITY          = 0x84EC ;
const uint GL_COMPRESSED_RGB                = 0x84ED ;
const uint GL_COMPRESSED_RGBA               = 0x84EE ;
const uint GL_TEXTURE_COMPRESSION_HINT      = 0x84EF ;
const uint GL_NORMAL_MAP                    = 0x8511 ;
const uint GL_REFLECTION_MAP                = 0x8512 ;
const uint GL_TEXTURE_CUBE_MAP              = 0x8513 ;
const uint GL_TEXTURE_BINDING_CUBE_MAP      = 0x8514 ;
const uint GL_TEXTURE_CUBE_MAP_POSITIVE_X   = 0x8515 ;
const uint GL_TEXTURE_CUBE_MAP_NEGATIVE_X   = 0x8516 ;
const uint GL_TEXTURE_CUBE_MAP_POSITIVE_Y   = 0x8517 ;
const uint GL_TEXTURE_CUBE_MAP_NEGATIVE_Y   = 0x8518 ;
const uint GL_TEXTURE_CUBE_MAP_POSITIVE_Z   = 0x8519 ;
const uint GL_TEXTURE_CUBE_MAP_NEGATIVE_Z   = 0x851A ;
const uint GL_PROXY_TEXTURE_CUBE_MAP        = 0x851B ;
const uint GL_MAX_CUBE_MAP_TEXTURE_SIZE     = 0x851C ;
const uint GL_COMBINE                       = 0x8570 ;
const uint GL_COMBINE_RGB                   = 0x8571 ;
const uint GL_COMBINE_ALPHA                 = 0x8572 ;
const uint GL_RGB_SCALE                     = 0x8573 ;
const uint GL_ADD_SIGNED                    = 0x8574 ;
const uint GL_INTERPOLATE                   = 0x8575 ;
const uint GL_CONSTANT                      = 0x8576 ;
const uint GL_PRIMARY_COLOR                 = 0x8577 ;
const uint GL_PREVIOUS                      = 0x8578 ;
const uint GL_SOURCE0_RGB                   = 0x8580 ;
const uint GL_SOURCE1_RGB                   = 0x8581 ;
const uint GL_SOURCE2_RGB                   = 0x8582 ;
const uint GL_SOURCE0_ALPHA                 = 0x8588 ;
const uint GL_SOURCE1_ALPHA                 = 0x8589 ;
const uint GL_SOURCE2_ALPHA                 = 0x858A ;
const uint GL_OPERAND0_RGB                  = 0x8590 ;
const uint GL_OPERAND1_RGB                  = 0x8591 ;
const uint GL_OPERAND2_RGB                  = 0x8592 ;
const uint GL_OPERAND0_ALPHA                = 0x8598 ;
const uint GL_OPERAND1_ALPHA                = 0x8599 ;
const uint GL_OPERAND2_ALPHA                = 0x859A ;
const uint GL_TEXTURE_COMPRESSED_IMAGE_SIZE = 0x86A0 ;
const uint GL_TEXTURE_COMPRESSED            = 0x86A1 ;
const uint GL_NUM_COMPRESSED_TEXTURE_FORMATS= 0x86A2 ;
const uint GL_COMPRESSED_TEXTURE_FORMATS    = 0x86A3 ;
const uint GL_DOT3_RGB                      = 0x86AE ;
const uint GL_DOT3_RGBA                     = 0x86AF ;
const uint GL_MULTISAMPLE_BIT               = 0x20000000 ;

extern(Windows){
alias void function(GLenum texture) PFNGLACTIVETEXTUREPROC ;
alias void function(GLenum texture) PFNGLCLIENTACTIVETEXTUREPROC ;
alias void function(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const GLvoid *data) PFNGLCOMPRESSEDTEXIMAGE1DPROC ;
alias void function(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *data) PFNGLCOMPRESSEDTEXIMAGE2DPROC ;
alias void function(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *data) PFNGLCOMPRESSEDTEXIMAGE3DPROC ;
alias void function(GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const GLvoid *data) PFNGLCOMPRESSEDTEXSUBIMAGE1DPROC ;
alias void function(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *data) PFNGLCOMPRESSEDTEXSUBIMAGE2DPROC ;
alias void function(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *data) PFNGLCOMPRESSEDTEXSUBIMAGE3DPROC ;
alias void function(GLenum target, GLint lod, GLvoid *img) PFNGLGETCOMPRESSEDTEXIMAGEPROC ;
alias void function(const GLdouble m[16]) PFNGLLOADTRANSPOSEMATRIXDPROC ;
alias void function(const GLfloat m[16]) PFNGLLOADTRANSPOSEMATRIXFPROC ;
alias void function(const GLdouble m[16]) PFNGLMULTTRANSPOSEMATRIXDPROC ;
alias void function(const GLfloat m[16]) PFNGLMULTTRANSPOSEMATRIXFPROC ;
alias void function(GLenum target, GLdouble s) PFNGLMULTITEXCOORD1DPROC ;
alias void function(GLenum target, const GLdouble *v) PFNGLMULTITEXCOORD1DVPROC ;
alias void function(GLenum target, GLfloat s) PFNGLMULTITEXCOORD1FPROC ;
alias void function(GLenum target, const GLfloat *v) PFNGLMULTITEXCOORD1FVPROC ;
alias void function(GLenum target, GLint s) PFNGLMULTITEXCOORD1IPROC ;
alias void function(GLenum target, const GLint *v) PFNGLMULTITEXCOORD1IVPROC ;
alias void function(GLenum target, GLshort s) PFNGLMULTITEXCOORD1SPROC ;
alias void function(GLenum target, const GLshort *v) PFNGLMULTITEXCOORD1SVPROC ;
alias void function(GLenum target, GLdouble s, GLdouble t) PFNGLMULTITEXCOORD2DPROC ;
alias void function(GLenum target, const GLdouble *v) PFNGLMULTITEXCOORD2DVPROC ;
alias void function(GLenum target, GLfloat s, GLfloat t) PFNGLMULTITEXCOORD2FPROC ;
alias void function(GLenum target, const GLfloat *v) PFNGLMULTITEXCOORD2FVPROC ;
alias void function(GLenum target, GLint s, GLint t) PFNGLMULTITEXCOORD2IPROC ;
alias void function(GLenum target, const GLint *v) PFNGLMULTITEXCOORD2IVPROC ;
alias void function(GLenum target, GLshort s, GLshort t) PFNGLMULTITEXCOORD2SPROC ;
alias void function(GLenum target, const GLshort *v) PFNGLMULTITEXCOORD2SVPROC ;
alias void function(GLenum target, GLdouble s, GLdouble t, GLdouble r) PFNGLMULTITEXCOORD3DPROC ;
alias void function(GLenum target, const GLdouble *v) PFNGLMULTITEXCOORD3DVPROC ;
alias void function(GLenum target, GLfloat s, GLfloat t, GLfloat r) PFNGLMULTITEXCOORD3FPROC ;
alias void function(GLenum target, const GLfloat *v) PFNGLMULTITEXCOORD3FVPROC ;
alias void function(GLenum target, GLint s, GLint t, GLint r) PFNGLMULTITEXCOORD3IPROC ;
alias void function(GLenum target, const GLint *v) PFNGLMULTITEXCOORD3IVPROC ;
alias void function(GLenum target, GLshort s, GLshort t, GLshort r) PFNGLMULTITEXCOORD3SPROC ;
alias void function(GLenum target, const GLshort *v) PFNGLMULTITEXCOORD3SVPROC ;
alias void function(GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q) PFNGLMULTITEXCOORD4DPROC ;
alias void function(GLenum target, const GLdouble *v) PFNGLMULTITEXCOORD4DVPROC ;
alias void function(GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q) PFNGLMULTITEXCOORD4FPROC ;
alias void function(GLenum target, const GLfloat *v) PFNGLMULTITEXCOORD4FVPROC ;
alias void function(GLenum target, GLint s, GLint t, GLint r, GLint q) PFNGLMULTITEXCOORD4IPROC ;
alias void function(GLenum target, const GLint *v) PFNGLMULTITEXCOORD4IVPROC ;
alias void function(GLenum target, GLshort s, GLshort t, GLshort r, GLshort q) PFNGLMULTITEXCOORD4SPROC ;
alias void function(GLenum target, const GLshort *v) PFNGLMULTITEXCOORD4SVPROC ;
alias void function(GLclampf value, GLboolean invert) PFNGLSAMPLECOVERAGEPROC ;

PFNGLACTIVETEXTUREPROC glActiveTexture ;
PFNGLCLIENTACTIVETEXTUREPROC glClientActiveTexture ;
PFNGLCOMPRESSEDTEXIMAGE1DPROC glCompressedTexImage1D ;
PFNGLCOMPRESSEDTEXIMAGE2DPROC glCompressedTexImage2D ;
PFNGLCOMPRESSEDTEXIMAGE3DPROC glCompressedTexImage3D ;
PFNGLCOMPRESSEDTEXSUBIMAGE1DPROC glCompressedTexSubImage1D ;
PFNGLCOMPRESSEDTEXSUBIMAGE2DPROC glCompressedTexSubImage2D ;
PFNGLCOMPRESSEDTEXSUBIMAGE3DPROC glCompressedTexSubImage3D ;
PFNGLGETCOMPRESSEDTEXIMAGEPROC glGetCompressedTexImage ;
PFNGLLOADTRANSPOSEMATRIXDPROC glLoadTransposeMatrixd ;
PFNGLLOADTRANSPOSEMATRIXFPROC glLoadTransposeMatrixf ;
PFNGLMULTTRANSPOSEMATRIXDPROC glMultTransposeMatrixd ;
PFNGLMULTTRANSPOSEMATRIXFPROC glMultTransposeMatrixf ;
PFNGLMULTITEXCOORD1DPROC glMultiTexCoord1d ;
PFNGLMULTITEXCOORD1DVPROC glMultiTexCoord1dv ;
PFNGLMULTITEXCOORD1FPROC glMultiTexCoord1f ;
PFNGLMULTITEXCOORD1FVPROC glMultiTexCoord1fv ;
PFNGLMULTITEXCOORD1IPROC glMultiTexCoord1i ;
PFNGLMULTITEXCOORD1IVPROC glMultiTexCoord1iv ;
PFNGLMULTITEXCOORD1SPROC glMultiTexCoord1s ;
PFNGLMULTITEXCOORD1SVPROC glMultiTexCoord1sv ;
PFNGLMULTITEXCOORD2DPROC glMultiTexCoord2d ;
PFNGLMULTITEXCOORD2DVPROC glMultiTexCoord2dv ;
PFNGLMULTITEXCOORD2FPROC glMultiTexCoord2f ;
PFNGLMULTITEXCOORD2FVPROC glMultiTexCoord2fv ;
PFNGLMULTITEXCOORD2IPROC glMultiTexCoord2i ;
PFNGLMULTITEXCOORD2IVPROC glMultiTexCoord2iv ;
PFNGLMULTITEXCOORD2SPROC glMultiTexCoord2s ;
PFNGLMULTITEXCOORD2SVPROC glMultiTexCoord2sv ;
PFNGLMULTITEXCOORD3DPROC glMultiTexCoord3d ;
PFNGLMULTITEXCOORD3DVPROC glMultiTexCoord3dv ;
PFNGLMULTITEXCOORD3FPROC glMultiTexCoord3f ;
PFNGLMULTITEXCOORD3FVPROC glMultiTexCoord3fv ;
PFNGLMULTITEXCOORD3IPROC glMultiTexCoord3i ;
PFNGLMULTITEXCOORD3IVPROC glMultiTexCoord3iv ;
PFNGLMULTITEXCOORD3SPROC glMultiTexCoord3s ;
PFNGLMULTITEXCOORD3SVPROC glMultiTexCoord3sv ;
PFNGLMULTITEXCOORD4DPROC glMultiTexCoord4d ;
PFNGLMULTITEXCOORD4DVPROC glMultiTexCoord4dv ;
PFNGLMULTITEXCOORD4FPROC glMultiTexCoord4f ;
PFNGLMULTITEXCOORD4FVPROC glMultiTexCoord4fv ;
PFNGLMULTITEXCOORD4IPROC glMultiTexCoord4i ;
PFNGLMULTITEXCOORD4IVPROC glMultiTexCoord4iv ;
PFNGLMULTITEXCOORD4SPROC glMultiTexCoord4s ;
PFNGLMULTITEXCOORD4SVPROC glMultiTexCoord4sv ;
PFNGLSAMPLECOVERAGEPROC glSampleCoverage ;
}

/* ----------------------------- GL_VERSION_1_4 ---------------------------- */
const uint GL_BLEND_DST_RGB                 = 0x80C8 ;
const uint GL_BLEND_SRC_RGB                 = 0x80C9 ;
const uint GL_BLEND_DST_ALPHA               = 0x80CA ;
const uint GL_BLEND_SRC_ALPHA               = 0x80CB ;
const uint GL_POINT_SIZE_MIN                = 0x8126 ;
const uint GL_POINT_SIZE_MAX                = 0x8127 ;
const uint GL_POINT_FADE_THRESHOLD_SIZE     = 0x8128 ;
const uint GL_POINT_DISTANCE_ATTENUATION    = 0x8129 ;
const uint GL_GENERATE_MIPMAP               = 0x8191 ;
const uint GL_GENERATE_MIPMAP_HINT          = 0x8192 ;
const uint GL_DEPTH_COMPONENT16             = 0x81A5 ;
const uint GL_DEPTH_COMPONENT24             = 0x81A6 ;
const uint GL_DEPTH_COMPONENT32             = 0x81A7 ;
const uint GL_MIRRORED_REPEAT               = 0x8370 ;
const uint GL_FOG_COORDINATE_SOURCE         = 0x8450 ;
const uint GL_FOG_COORDINATE                = 0x8451 ;
const uint GL_FRAGMENT_DEPTH                = 0x8452 ;
const uint GL_CURRENT_FOG_COORDINATE        = 0x8453 ;
const uint GL_FOG_COORDINATE_ARRAY_TYPE     = 0x8454 ;
const uint GL_FOG_COORDINATE_ARRAY_STRIDE   = 0x8455 ;
const uint GL_FOG_COORDINATE_ARRAY_POINTER  = 0x8456 ;
const uint GL_FOG_COORDINATE_ARRAY          = 0x8457 ;
const uint GL_COLOR_SUM                     = 0x8458 ;
const uint GL_CURRENT_SECONDARY_COLOR       = 0x8459 ;
const uint GL_SECONDARY_COLOR_ARRAY_SIZE    = 0x845A ;
const uint GL_SECONDARY_COLOR_ARRAY_TYPE    = 0x845B ;
const uint GL_SECONDARY_COLOR_ARRAY_STRIDE  = 0x845C ;
const uint GL_SECONDARY_COLOR_ARRAY_POINTER = 0x845D ;
const uint GL_SECONDARY_COLOR_ARRAY         = 0x845E ;
const uint GL_MAX_TEXTURE_LOD_BIAS          = 0x84FD ;
const uint GL_TEXTURE_FILTER_CONTROL        = 0x8500 ;
const uint GL_TEXTURE_LOD_BIAS              = 0x8501 ;
const uint GL_INCR_WRAP                     = 0x8507 ;
const uint GL_DECR_WRAP                     = 0x8508 ;
const uint GL_TEXTURE_DEPTH_SIZE            = 0x884A ;
const uint GL_DEPTH_TEXTURE_MODE            = 0x884B ;
const uint GL_TEXTURE_COMPARE_MODE          = 0x884C ;
const uint GL_TEXTURE_COMPARE_FUNC          = 0x884D ;
const uint GL_COMPARE_R_TO_TEXTURE          = 0x884E ;

extern(Windows){
alias void function(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha) PFNGLBLENDCOLORPROC ;
alias void function(GLenum mode) PFNGLBLENDEQUATIONPROC ;
alias void function(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha) PFNGLBLENDFUNCSEPARATEPROC ;
alias void function(GLenum type, GLsizei stride, const GLvoid *pointer) PFNGLFOGCOORDPOINTERPROC ;
alias void function(GLdouble coord) PFNGLFOGCOORDDPROC ;
alias void function(const GLdouble *coord) PFNGLFOGCOORDDVPROC ;
alias void function(GLfloat coord) PFNGLFOGCOORDFPROC ;
alias void function(const GLfloat *coord) PFNGLFOGCOORDFVPROC ;
alias void function(GLenum mode, GLint *first, GLsizei *count, GLsizei primcount) PFNGLMULTIDRAWARRAYSPROC ;
alias void function(GLenum mode, GLsizei *count, GLenum type, const GLvoid **indices, GLsizei primcount) PFNGLMULTIDRAWELEMENTSPROC ;
alias void function(GLenum pname, GLfloat param) PFNGLPOINTPARAMETERFPROC ;
alias void function(GLenum pname, GLfloat *params) PFNGLPOINTPARAMETERFVPROC ;
alias void function(GLenum pname, GLint param) PFNGLPOINTPARAMETERIPROC ;
alias void function(GLenum pname, GLint *params) PFNGLPOINTPARAMETERIVPROC ;
alias void function(GLbyte red, GLbyte green, GLbyte blue) PFNGLSECONDARYCOLOR3BPROC ;
alias void function(const GLbyte *v) PFNGLSECONDARYCOLOR3BVPROC ;
alias void function(GLdouble red, GLdouble green, GLdouble blue) PFNGLSECONDARYCOLOR3DPROC ;
alias void function(const GLdouble *v) PFNGLSECONDARYCOLOR3DVPROC ;
alias void function(GLfloat red, GLfloat green, GLfloat blue) PFNGLSECONDARYCOLOR3FPROC ;
alias void function(const GLfloat *v) PFNGLSECONDARYCOLOR3FVPROC ;
alias void function(GLint red, GLint green, GLint blue) PFNGLSECONDARYCOLOR3IPROC ;
alias void function(const GLint *v) PFNGLSECONDARYCOLOR3IVPROC ;
alias void function(GLshort red, GLshort green, GLshort blue) PFNGLSECONDARYCOLOR3SPROC ;
alias void function(const GLshort *v) PFNGLSECONDARYCOLOR3SVPROC ;
alias void function(GLubyte red, GLubyte green, GLubyte blue) PFNGLSECONDARYCOLOR3UBPROC ;
alias void function(const GLubyte *v) PFNGLSECONDARYCOLOR3UBVPROC ;
alias void function(GLuint red, GLuint green, GLuint blue) PFNGLSECONDARYCOLOR3UIPROC ;
alias void function(const GLuint *v) PFNGLSECONDARYCOLOR3UIVPROC ;
alias void function(GLushort red, GLushort green, GLushort blue) PFNGLSECONDARYCOLOR3USPROC ;
alias void function(const GLushort *v) PFNGLSECONDARYCOLOR3USVPROC ;
alias void function(GLint size, GLenum type, GLsizei stride, GLvoid *pointer) PFNGLSECONDARYCOLORPOINTERPROC ;
alias void function(GLdouble x, GLdouble y) PFNGLWINDOWPOS2DPROC ;
alias void function(const GLdouble *p) PFNGLWINDOWPOS2DVPROC ;
alias void function(GLfloat x, GLfloat y) PFNGLWINDOWPOS2FPROC ;
alias void function(const GLfloat *p) PFNGLWINDOWPOS2FVPROC ;
alias void function(GLint x, GLint y) PFNGLWINDOWPOS2IPROC ;
alias void function(const GLint *p) PFNGLWINDOWPOS2IVPROC ;
alias void function(GLshort x, GLshort y) PFNGLWINDOWPOS2SPROC ;
alias void function(const GLshort *p) PFNGLWINDOWPOS2SVPROC ;
alias void function(GLdouble x, GLdouble y, GLdouble z) PFNGLWINDOWPOS3DPROC ;
alias void function(const GLdouble *p) PFNGLWINDOWPOS3DVPROC ;
alias void function(GLfloat x, GLfloat y, GLfloat z) PFNGLWINDOWPOS3FPROC ;
alias void function(const GLfloat *p) PFNGLWINDOWPOS3FVPROC ;
alias void function(GLint x, GLint y, GLint z) PFNGLWINDOWPOS3IPROC ;
alias void function(const GLint *p) PFNGLWINDOWPOS3IVPROC ;
alias void function(GLshort x, GLshort y, GLshort z) PFNGLWINDOWPOS3SPROC ;
alias void function(const GLshort *p) PFNGLWINDOWPOS3SVPROC ;

PFNGLBLENDCOLORPROC glBlendColor ;
PFNGLBLENDEQUATIONPROC glBlendEquation ;
PFNGLBLENDFUNCSEPARATEPROC glBlendFuncSeparate ;
PFNGLFOGCOORDPOINTERPROC glFogCoordPointer ;
PFNGLFOGCOORDDPROC glFogCoordd ;
PFNGLFOGCOORDDVPROC glFogCoorddv ;
PFNGLFOGCOORDFPROC glFogCoordf ;
PFNGLFOGCOORDFVPROC glFogCoordfv ;
PFNGLMULTIDRAWARRAYSPROC glMultiDrawArrays ;
PFNGLMULTIDRAWELEMENTSPROC glMultiDrawElements ;
PFNGLPOINTPARAMETERFPROC glPointParameterf ;
PFNGLPOINTPARAMETERFVPROC glPointParameterfv ;
PFNGLPOINTPARAMETERIPROC glPointParameteri ;
PFNGLPOINTPARAMETERIVPROC glPointParameteriv ;
PFNGLSECONDARYCOLOR3BPROC glSecondaryColor3b ;
PFNGLSECONDARYCOLOR3BVPROC glSecondaryColor3bv ;
PFNGLSECONDARYCOLOR3DPROC glSecondaryColor3d ;
PFNGLSECONDARYCOLOR3DVPROC glSecondaryColor3dv ;
PFNGLSECONDARYCOLOR3FPROC glSecondaryColor3f ;
PFNGLSECONDARYCOLOR3FVPROC glSecondaryColor3fv ;
PFNGLSECONDARYCOLOR3IPROC glSecondaryColor3i ;
PFNGLSECONDARYCOLOR3IVPROC glSecondaryColor3iv ;
PFNGLSECONDARYCOLOR3SPROC glSecondaryColor3s ;
PFNGLSECONDARYCOLOR3SVPROC glSecondaryColor3sv ;
PFNGLSECONDARYCOLOR3UBPROC glSecondaryColor3ub ;
PFNGLSECONDARYCOLOR3UBVPROC glSecondaryColor3ubv ;
PFNGLSECONDARYCOLOR3UIPROC glSecondaryColor3ui ;
PFNGLSECONDARYCOLOR3UIVPROC glSecondaryColor3uiv ;
PFNGLSECONDARYCOLOR3USPROC glSecondaryColor3us ;
PFNGLSECONDARYCOLOR3USVPROC glSecondaryColor3usv ;
PFNGLSECONDARYCOLORPOINTERPROC glSecondaryColorPointer ;
PFNGLWINDOWPOS2DPROC glWindowPos2d ;
PFNGLWINDOWPOS2DVPROC glWindowPos2dv ;
PFNGLWINDOWPOS2FPROC glWindowPos2f ;
PFNGLWINDOWPOS2FVPROC glWindowPos2fv ;
PFNGLWINDOWPOS2IPROC glWindowPos2i ;
PFNGLWINDOWPOS2IVPROC glWindowPos2iv ;
PFNGLWINDOWPOS2SPROC glWindowPos2s ;
PFNGLWINDOWPOS2SVPROC glWindowPos2sv ;
PFNGLWINDOWPOS3DPROC glWindowPos3d ;
PFNGLWINDOWPOS3DVPROC glWindowPos3dv ;
PFNGLWINDOWPOS3FPROC glWindowPos3f ;
PFNGLWINDOWPOS3FVPROC glWindowPos3fv ;
PFNGLWINDOWPOS3IPROC glWindowPos3i ;
PFNGLWINDOWPOS3IVPROC glWindowPos3iv ;
PFNGLWINDOWPOS3SPROC glWindowPos3s ;
PFNGLWINDOWPOS3SVPROC glWindowPos3sv ;
}

/* ----------------------------- GL_VERSION_1_5 ---------------------------- */
const uint GL_FOG_COORD_SRC                        = GL_FOG_COORDINATE_SOURCE ;
const uint GL_FOG_COORD                            = GL_FOG_COORDINATE ;
const uint GL_FOG_COORD_ARRAY                      = GL_FOG_COORDINATE_ARRAY ;
const uint GL_SRC0_RGB                             = GL_SOURCE0_RGB ;
const uint GL_FOG_COORD_ARRAY_POINTER              = GL_FOG_COORDINATE_ARRAY_POINTER ;
const uint GL_FOG_COORD_ARRAY_TYPE                 = GL_FOG_COORDINATE_ARRAY_TYPE ;
const uint GL_SRC1_ALPHA                           = GL_SOURCE1_ALPHA ;
const uint GL_CURRENT_FOG_COORD                    = GL_CURRENT_FOG_COORDINATE ;
const uint GL_FOG_COORD_ARRAY_STRIDE               = GL_FOG_COORDINATE_ARRAY_STRIDE ;
const uint GL_SRC0_ALPHA                           = GL_SOURCE0_ALPHA ;
const uint GL_SRC1_RGB                             = GL_SOURCE1_RGB ;
const uint GL_FOG_COORD_ARRAY_BUFFER_BINDING       = GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING ;
const uint GL_SRC2_ALPHA                           = GL_SOURCE2_ALPHA ;
const uint GL_SRC2_RGB                             = GL_SOURCE2_RGB ;
const uint GL_BUFFER_SIZE                          = 0x8764 ;
const uint GL_BUFFER_USAGE                         = 0x8765 ;
const uint GL_QUERY_COUNTER_BITS                   = 0x8864 ;
const uint GL_CURRENT_QUERY                        = 0x8865 ;
const uint GL_QUERY_RESULT                         = 0x8866 ;
const uint GL_QUERY_RESULT_AVAILABLE               = 0x8867 ;
const uint GL_ARRAY_BUFFER                         = 0x8892 ;
const uint GL_ELEMENT_ARRAY_BUFFER                 = 0x8893 ;
const uint GL_ARRAY_BUFFER_BINDING                 = 0x8894 ;
const uint GL_ELEMENT_ARRAY_BUFFER_BINDING         = 0x8895 ;
const uint GL_VERTEX_ARRAY_BUFFER_BINDING          = 0x8896 ;
const uint GL_NORMAL_ARRAY_BUFFER_BINDING          = 0x8897 ;
const uint GL_COLOR_ARRAY_BUFFER_BINDING           = 0x8898 ;
const uint GL_INDEX_ARRAY_BUFFER_BINDING           = 0x8899 ;
const uint GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING   = 0x889A ;
const uint GL_EDGE_FLAG_ARRAY_BUFFER_BINDING       = 0x889B ;
const uint GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING = 0x889C ;
const uint GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING  = 0x889D ;
const uint GL_WEIGHT_ARRAY_BUFFER_BINDING          = 0x889E ;
const uint GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING   = 0x889F ;
const uint GL_READ_ONLY                            = 0x88B8 ;
const uint GL_WRITE_ONLY                           = 0x88B9 ;
const uint GL_READ_WRITE                           = 0x88BA ;
const uint GL_BUFFER_ACCESS                        = 0x88BB ;
const uint GL_BUFFER_MAPPED                        = 0x88BC ;
const uint GL_BUFFER_MAP_POINTER                   = 0x88BD ;
const uint GL_STREAM_DRAW                          = 0x88E0 ;
const uint GL_STREAM_READ                          = 0x88E1 ;
const uint GL_STREAM_COPY                          = 0x88E2 ;
const uint GL_STATIC_DRAW                          = 0x88E4 ;
const uint GL_STATIC_READ                          = 0x88E5 ;
const uint GL_STATIC_COPY                          = 0x88E6 ;
const uint GL_DYNAMIC_DRAW                         = 0x88E8 ;
const uint GL_DYNAMIC_READ                         = 0x88E9 ;
const uint GL_DYNAMIC_COPY                         = 0x88EA ;
const uint GL_SAMPLES_PASSED                       = 0x8914 ;

alias int GLsizeiptr;
alias int GLintptr;

extern(Windows){
alias void function(GLenum target, GLuint id) PFNGLBEGINQUERYPROC ;
alias void function(GLenum target, GLuint buffer) PFNGLBINDBUFFERPROC ;
alias void function(GLenum target, GLsizeiptr size, const GLvoid* data, GLenum usage) PFNGLBUFFERDATAPROC ;
alias void function(GLenum target, GLintptr offset, GLsizeiptr size, const GLvoid* data) PFNGLBUFFERSUBDATAPROC ;
alias void function(GLsizei n, const GLuint* buffers) PFNGLDELETEBUFFERSPROC ;
alias void function(GLsizei n, const GLuint* ids) PFNGLDELETEQUERIESPROC ;
alias void function(GLenum target) PFNGLENDQUERYPROC ;
alias void function(GLsizei n, GLuint* buffers) PFNGLGENBUFFERSPROC ;
alias void function(GLsizei n, GLuint* ids) PFNGLGENQUERIESPROC ;
alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETBUFFERPARAMETERIVPROC ;
alias void function(GLenum target, GLenum pname, GLvoid** params) PFNGLGETBUFFERPOINTERVPROC ;
alias void function(GLenum target, GLintptr offset, GLsizeiptr size, GLvoid* data) PFNGLGETBUFFERSUBDATAPROC ;
alias void function(GLuint id, GLenum pname, GLint* params) PFNGLGETQUERYOBJECTIVPROC ;
alias void function(GLuint id, GLenum pname, GLuint* params) PFNGLGETQUERYOBJECTUIVPROC ;
alias void function(GLenum target, GLenum pname, GLint* params) PFNGLGETQUERYIVPROC ;
alias GLboolean function(GLuint buffer) PFNGLISBUFFERPROC ;
alias GLboolean function(GLuint id) PFNGLISQUERYPROC ;
alias GLvoid* function(GLenum target, GLenum access) PFNGLMAPBUFFERPROC ;
alias GLboolean function(GLenum target) PFNGLUNMAPBUFFERPROC ;

PFNGLBEGINQUERYPROC glBeginQuery ;
PFNGLBINDBUFFERPROC glBindBuffer ;
PFNGLBUFFERDATAPROC glBufferData ;
PFNGLBUFFERSUBDATAPROC glBufferSubData ;
PFNGLDELETEBUFFERSPROC glDeleteBuffers ;
PFNGLDELETEQUERIESPROC glDeleteQueries ;
PFNGLENDQUERYPROC glEndQuery ;
PFNGLGENBUFFERSPROC glGenBuffers ;
PFNGLGENQUERIESPROC glGenQueries ;
PFNGLGETBUFFERPARAMETERIVPROC glGetBufferParameteriv ;
PFNGLGETBUFFERPOINTERVPROC glGetBufferPointerv ;
PFNGLGETBUFFERSUBDATAPROC glGetBufferSubData ;
PFNGLGETQUERYOBJECTIVPROC glGetQueryObjectiv ;
PFNGLGETQUERYOBJECTUIVPROC glGetQueryObjectuiv ;
PFNGLGETQUERYIVPROC glGetQueryiv ;
PFNGLISBUFFERPROC glIsBuffer ;
PFNGLISQUERYPROC glIsQuery ;
PFNGLMAPBUFFERPROC glMapBuffer ;
PFNGLUNMAPBUFFERPROC glUnmapBuffer ;
}

/* ----------------------------- GL_VERSION_2_0 ---------------------------- */
const uint GL_BLEND_EQUATION_RGB               = GL_BLEND_EQUATION ;
const uint GL_VERTEX_ATTRIB_ARRAY_ENABLED      = 0x8622 ;
const uint GL_VERTEX_ATTRIB_ARRAY_SIZE         = 0x8623 ;
const uint GL_VERTEX_ATTRIB_ARRAY_STRIDE       = 0x8624 ;
const uint GL_VERTEX_ATTRIB_ARRAY_TYPE         = 0x8625 ;
const uint GL_CURRENT_VERTEX_ATTRIB            = 0x8626 ;
const uint GL_VERTEX_PROGRAM_POINT_SIZE        = 0x8642 ;
const uint GL_VERTEX_PROGRAM_TWO_SIDE          = 0x8643 ;
const uint GL_VERTEX_ATTRIB_ARRAY_POINTER      = 0x8645 ;
const uint GL_STENCIL_BACK_FUNC                = 0x8800 ;
const uint GL_STENCIL_BACK_FAIL                = 0x8801 ;
const uint GL_STENCIL_BACK_PASS_DEPTH_FAIL     = 0x8802 ;
const uint GL_STENCIL_BACK_PASS_DEPTH_PASS     = 0x8803 ;
const uint GL_MAX_DRAW_BUFFERS                 = 0x8824 ;
const uint GL_DRAW_BUFFER0                     = 0x8825 ;
const uint GL_DRAW_BUFFER1                     = 0x8826 ;
const uint GL_DRAW_BUFFER2                     = 0x8827 ;
const uint GL_DRAW_BUFFER3                     = 0x8828 ;
const uint GL_DRAW_BUFFER4                     = 0x8829 ;
const uint GL_DRAW_BUFFER5                     = 0x882A ;
const uint GL_DRAW_BUFFER6                     = 0x882B ;
const uint GL_DRAW_BUFFER7                     = 0x882C ;
const uint GL_DRAW_BUFFER8                     = 0x882D ;
const uint GL_DRAW_BUFFER9                     = 0x882E ;
const uint GL_DRAW_BUFFER10                    = 0x882F ;
const uint GL_DRAW_BUFFER11                    = 0x8830 ;
const uint GL_DRAW_BUFFER12                    = 0x8831 ;
const uint GL_DRAW_BUFFER13                    = 0x8832 ;
const uint GL_DRAW_BUFFER14                    = 0x8833 ;
const uint GL_DRAW_BUFFER15                    = 0x8834 ;
const uint GL_BLEND_EQUATION_ALPHA             = 0x883D ;
const uint GL_POINT_SPRITE                     = 0x8861 ;
const uint GL_COORD_REPLACE                    = 0x8862 ;
const uint GL_MAX_VERTEX_ATTRIBS               = 0x8869 ;
const uint GL_VERTEX_ATTRIB_ARRAY_NORMALIZED   = 0x886A ;
const uint GL_MAX_TEXTURE_COORDS               = 0x8871 ;
const uint GL_MAX_TEXTURE_IMAGE_UNITS          = 0x8872 ;
const uint GL_FRAGMENT_SHADER                  = 0x8B30 ;
const uint GL_VERTEX_SHADER                    = 0x8B31 ;
const uint GL_MAX_FRAGMENT_UNIFORM_COMPONENTS  = 0x8B49 ;
const uint GL_MAX_VERTEX_UNIFORM_COMPONENTS    = 0x8B4A ;
const uint GL_MAX_VARYING_FLOATS               = 0x8B4B ;
const uint GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS   = 0x8B4C ;
const uint GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS = 0x8B4D ;
const uint GL_SHADER_TYPE                      = 0x8B4F ;
const uint GL_FLOAT_VEC2                       = 0x8B50 ;
const uint GL_FLOAT_VEC3                       = 0x8B51 ;
const uint GL_FLOAT_VEC4                       = 0x8B52 ;
const uint GL_INT_VEC2                         = 0x8B53 ;
const uint GL_INT_VEC3                         = 0x8B54 ;
const uint GL_INT_VEC4                         = 0x8B55 ;
const uint GL_BOOL                             = 0x8B56 ;
const uint GL_BOOL_VEC2                        = 0x8B57 ;
const uint GL_BOOL_VEC3                        = 0x8B58 ;
const uint GL_BOOL_VEC4                        = 0x8B59 ;
const uint GL_FLOAT_MAT2                       = 0x8B5A ;
const uint GL_FLOAT_MAT3                       = 0x8B5B ;
const uint GL_FLOAT_MAT4                       = 0x8B5C ;
const uint GL_SAMPLER_1D                       = 0x8B5D ;
const uint GL_SAMPLER_2D                       = 0x8B5E ;
const uint GL_SAMPLER_3D                       = 0x8B5F ;
const uint GL_SAMPLER_CUBE                     = 0x8B60 ;
const uint GL_SAMPLER_1D_SHADOW                = 0x8B61 ;
const uint GL_SAMPLER_2D_SHADOW                = 0x8B62 ;
const uint GL_DELETE_STATUS                    = 0x8B80 ;
const uint GL_COMPILE_STATUS                   = 0x8B81 ;
const uint GL_LINK_STATUS                      = 0x8B82 ;
const uint GL_VALIDATE_STATUS                  = 0x8B83 ;
const uint GL_INFO_LOG_LENGTH                  = 0x8B84 ;
const uint GL_ATTACHED_SHADERS                 = 0x8B85 ;
const uint GL_ACTIVE_UNIFORMS                  = 0x8B86 ;
const uint GL_ACTIVE_UNIFORM_MAX_LENGTH        = 0x8B87 ;
const uint GL_SHADER_SOURCE_LENGTH             = 0x8B88 ;
const uint GL_ACTIVE_ATTRIBUTES                = 0x8B89 ;
const uint GL_ACTIVE_ATTRIBUTE_MAX_LENGTH      = 0x8B8A ;
const uint GL_FRAGMENT_SHADER_DERIVATIVE_HINT  = 0x8B8B ;
const uint GL_SHADING_LANGUAGE_VERSION         = 0x8B8C ;
const uint GL_CURRENT_PROGRAM                  = 0x8B8D ;
const uint GL_POINT_SPRITE_COORD_ORIGIN        = 0x8CA0 ;
const uint GL_LOWER_LEFT                       = 0x8CA1 ;
const uint GL_UPPER_LEFT                       = 0x8CA2 ;
const uint GL_STENCIL_BACK_REF                 = 0x8CA3 ;
const uint GL_STENCIL_BACK_VALUE_MASK          = 0x8CA4 ;
const uint GL_STENCIL_BACK_WRITEMASK           = 0x8CA5 ;

alias char GLchar;

extern(Windows){
alias void function(GLuint program, GLuint shader) PFNGLATTACHSHADERPROC ;
alias void function(GLuint program, GLuint index, const GLchar* name) PFNGLBINDATTRIBLOCATIONPROC ;
alias void function(GLenum, GLenum) PFNGLBLENDEQUATIONSEPARATEPROC ;
alias void function(GLuint shader) PFNGLCOMPILESHADERPROC ;
alias GLuint function() PFNGLCREATEPROGRAMPROC ;
alias GLuint function(GLenum type) PFNGLCREATESHADERPROC ;
alias void function(GLuint program) PFNGLDELETEPROGRAMPROC ;
alias void function(GLuint shader) PFNGLDELETESHADERPROC ;
alias void function(GLuint program, GLuint shader) PFNGLDETACHSHADERPROC ;
alias void function(GLuint) PFNGLDISABLEVERTEXATTRIBARRAYPROC ;
alias void function(GLsizei n, const GLenum* bufs) PFNGLDRAWBUFFERSPROC ;
alias void function(GLuint) PFNGLENABLEVERTEXATTRIBARRAYPROC ;
alias void function(GLuint program, GLuint index, GLsizei maxLength, GLsizei* length, GLint* size, GLenum* type, GLchar* name) PFNGLGETACTIVEATTRIBPROC ;
alias void function(GLuint program, GLuint index, GLsizei maxLength, GLsizei* length, GLint* size, GLenum* type, GLchar* name) PFNGLGETACTIVEUNIFORMPROC ;
alias void function(GLuint program, GLsizei maxCount, GLsizei* count, GLuint* shaders) PFNGLGETATTACHEDSHADERSPROC ;
alias GLint function(GLuint program, const GLchar* name) PFNGLGETATTRIBLOCATIONPROC ;
alias void function(GLuint program, GLsizei bufSize, GLsizei* length, GLchar* infoLog) PFNGLGETPROGRAMINFOLOGPROC ;
alias void function(GLuint program, GLenum pname, GLint* param) PFNGLGETPROGRAMIVPROC ;
alias void function(GLuint shader, GLsizei bufSize, GLsizei* length, GLchar* infoLog) PFNGLGETSHADERINFOLOGPROC ;
alias void function(GLint obj, GLsizei maxLength, GLsizei* length, GLchar* source) PFNGLGETSHADERSOURCEPROC ;
alias void function(GLuint shader, GLenum pname, GLint* param) PFNGLGETSHADERIVPROC ;
alias GLint function(GLuint program, const GLchar* name) PFNGLGETUNIFORMLOCATIONPROC ;
alias void function(GLuint program, GLint location, GLfloat* params) PFNGLGETUNIFORMFVPROC ;
alias void function(GLuint program, GLint location, GLint* params) PFNGLGETUNIFORMIVPROC ;
alias void function(GLuint, GLenum, GLvoid*) PFNGLGETVERTEXATTRIBPOINTERVPROC ;
alias void function(GLuint, GLenum, GLdouble*) PFNGLGETVERTEXATTRIBDVPROC ;
alias void function(GLuint, GLenum, GLfloat*) PFNGLGETVERTEXATTRIBFVPROC ;
alias void function(GLuint, GLenum, GLint*) PFNGLGETVERTEXATTRIBIVPROC ;
alias GLboolean function(GLuint program) PFNGLISPROGRAMPROC ;
alias GLboolean function(GLuint shader) PFNGLISSHADERPROC ;
alias void function(GLuint program) PFNGLLINKPROGRAMPROC ;
alias void function(GLuint shader, GLsizei count, const GLchar** strings, const GLint* lengths) PFNGLSHADERSOURCEPROC ;
alias void function(GLenum frontfunc, GLenum backfunc, GLint value, GLuint mask) PFNGLSTENCILFUNCSEPARATEPROC ;
alias void function(GLenum, GLuint) PFNGLSTENCILMASKSEPARATEPROC ;
alias void function(GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass) PFNGLSTENCILOPSEPARATEPROC ;
alias void function(GLint location, GLfloat v0) PFNGLUNIFORM1FPROC ;
alias void function(GLint location, GLsizei count, const GLfloat* value) PFNGLUNIFORM1FVPROC ;
alias void function(GLint location, GLint v0) PFNGLUNIFORM1IPROC ;
alias void function(GLint location, GLsizei count, const GLint* value) PFNGLUNIFORM1IVPROC ;
alias void function(GLint location, GLfloat v0, GLfloat v1) PFNGLUNIFORM2FPROC ;
alias void function(GLint location, GLsizei count, const GLfloat* value) PFNGLUNIFORM2FVPROC ;
alias void function(GLint location, GLint v0, GLint v1) PFNGLUNIFORM2IPROC ;
alias void function(GLint location, GLsizei count, const GLint* value) PFNGLUNIFORM2IVPROC ;
alias void function(GLint location, GLfloat v0, GLfloat v1, GLfloat v2) PFNGLUNIFORM3FPROC ;
alias void function(GLint location, GLsizei count, const GLfloat* value) PFNGLUNIFORM3FVPROC ;
alias void function(GLint location, GLint v0, GLint v1, GLint v2) PFNGLUNIFORM3IPROC ;
alias void function(GLint location, GLsizei count, const GLint* value) PFNGLUNIFORM3IVPROC ;
alias void function(GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3) PFNGLUNIFORM4FPROC ;
alias void function(GLint location, GLsizei count, const GLfloat* value) PFNGLUNIFORM4FVPROC ;
alias void function(GLint location, GLint v0, GLint v1, GLint v2, GLint v3) PFNGLUNIFORM4IPROC ;
alias void function(GLint location, GLsizei count, const GLint* value) PFNGLUNIFORM4IVPROC ;
alias void function(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value) PFNGLUNIFORMMATRIX2FVPROC ;
alias void function(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value) PFNGLUNIFORMMATRIX3FVPROC ;
alias void function(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value) PFNGLUNIFORMMATRIX4FVPROC ;
alias void function(GLuint program) PFNGLUSEPROGRAMPROC ;
alias void function(GLuint program) PFNGLVALIDATEPROGRAMPROC ;
alias void function(GLuint index, GLdouble x) PFNGLVERTEXATTRIB1DPROC ;
alias void function(GLuint index, const GLdouble* v) PFNGLVERTEXATTRIB1DVPROC ;
alias void function(GLuint index, GLfloat x) PFNGLVERTEXATTRIB1FPROC ;
alias void function(GLuint index, const GLfloat* v) PFNGLVERTEXATTRIB1FVPROC ;
alias void function(GLuint index, GLshort x) PFNGLVERTEXATTRIB1SPROC ;
alias void function(GLuint index, const GLshort* v) PFNGLVERTEXATTRIB1SVPROC ;
alias void function(GLuint index, GLdouble x, GLdouble y) PFNGLVERTEXATTRIB2DPROC ;
alias void function(GLuint index, const GLdouble* v) PFNGLVERTEXATTRIB2DVPROC ;
alias void function(GLuint index, GLfloat x, GLfloat y) PFNGLVERTEXATTRIB2FPROC ;
alias void function(GLuint index, const GLfloat* v) PFNGLVERTEXATTRIB2FVPROC ;
alias void function(GLuint index, GLshort x, GLshort y) PFNGLVERTEXATTRIB2SPROC ;
alias void function(GLuint index, const GLshort* v) PFNGLVERTEXATTRIB2SVPROC ;
alias void function(GLuint index, GLdouble x, GLdouble y, GLdouble z) PFNGLVERTEXATTRIB3DPROC ;
alias void function(GLuint index, const GLdouble* v) PFNGLVERTEXATTRIB3DVPROC ;
alias void function(GLuint index, GLfloat x, GLfloat y, GLfloat z) PFNGLVERTEXATTRIB3FPROC ;
alias void function(GLuint index, const GLfloat* v) PFNGLVERTEXATTRIB3FVPROC ;
alias void function(GLuint index, GLshort x, GLshort y, GLshort z) PFNGLVERTEXATTRIB3SPROC ;
alias void function(GLuint index, const GLshort* v) PFNGLVERTEXATTRIB3SVPROC ;
alias void function(GLuint index, const GLbyte* v) PFNGLVERTEXATTRIB4NBVPROC ;
alias void function(GLuint index, const GLint* v) PFNGLVERTEXATTRIB4NIVPROC ;
alias void function(GLuint index, const GLshort* v) PFNGLVERTEXATTRIB4NSVPROC ;
alias void function(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w) PFNGLVERTEXATTRIB4NUBPROC ;
alias void function(GLuint index, const GLubyte* v) PFNGLVERTEXATTRIB4NUBVPROC ;
alias void function(GLuint index, const GLuint* v) PFNGLVERTEXATTRIB4NUIVPROC ;
alias void function(GLuint index, const GLushort* v) PFNGLVERTEXATTRIB4NUSVPROC ;
alias void function(GLuint index, const GLbyte* v) PFNGLVERTEXATTRIB4BVPROC ;
alias void function(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w) PFNGLVERTEXATTRIB4DPROC ;
alias void function(GLuint index, const GLdouble* v) PFNGLVERTEXATTRIB4DVPROC ;
alias void function(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w) PFNGLVERTEXATTRIB4FPROC ;
alias void function(GLuint index, const GLfloat* v) PFNGLVERTEXATTRIB4FVPROC ;
alias void function(GLuint index, const GLint* v) PFNGLVERTEXATTRIB4IVPROC ;
alias void function(GLuint index, GLshort x, GLshort y, GLshort z, GLshort w) PFNGLVERTEXATTRIB4SPROC ;
alias void function(GLuint index, const GLshort* v) PFNGLVERTEXATTRIB4SVPROC ;
alias void function(GLuint index, const GLubyte* v) PFNGLVERTEXATTRIB4UBVPROC ;
alias void function(GLuint index, const GLuint* v) PFNGLVERTEXATTRIB4UIVPROC ;
alias void function(GLuint index, const GLushort* v) PFNGLVERTEXATTRIB4USVPROC ;
alias void function(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const GLvoid* pointer) PFNGLVERTEXATTRIBPOINTERPROC ;

PFNGLATTACHSHADERPROC glAttachShader ;
PFNGLBINDATTRIBLOCATIONPROC glBindAttribLocation ;
PFNGLBLENDEQUATIONSEPARATEPROC glBlendEquationSeparate ;
PFNGLCOMPILESHADERPROC glCompileShader ;
PFNGLCREATEPROGRAMPROC glCreateProgram ;
PFNGLCREATESHADERPROC glCreateShader ;
PFNGLDELETEPROGRAMPROC glDeleteProgram ;
PFNGLDELETESHADERPROC glDeleteShader ;
PFNGLDETACHSHADERPROC glDetachShader ;
PFNGLDISABLEVERTEXATTRIBARRAYPROC glDisableVertexAttribArray ;
PFNGLDRAWBUFFERSPROC glDrawBuffers ;
PFNGLENABLEVERTEXATTRIBARRAYPROC glEnableVertexAttribArray ;
PFNGLGETACTIVEATTRIBPROC glGetActiveAttrib ;
PFNGLGETACTIVEUNIFORMPROC glGetActiveUniform ;
PFNGLGETATTACHEDSHADERSPROC glGetAttachedShaders ;
PFNGLGETATTRIBLOCATIONPROC glGetAttribLocation ;
PFNGLGETPROGRAMINFOLOGPROC glGetProgramInfoLog ;
PFNGLGETPROGRAMIVPROC glGetProgramiv ;
PFNGLGETSHADERINFOLOGPROC glGetShaderInfoLog ;
PFNGLGETSHADERSOURCEPROC glGetShaderSource ;
PFNGLGETSHADERIVPROC glGetShaderiv ;
PFNGLGETUNIFORMLOCATIONPROC glGetUniformLocation ;
PFNGLGETUNIFORMFVPROC glGetUniformfv ;
PFNGLGETUNIFORMIVPROC glGetUniformiv ;
PFNGLGETVERTEXATTRIBPOINTERVPROC glGetVertexAttribPointerv ;
PFNGLGETVERTEXATTRIBDVPROC glGetVertexAttribdv ;
PFNGLGETVERTEXATTRIBFVPROC glGetVertexAttribfv ;
PFNGLGETVERTEXATTRIBIVPROC glGetVertexAttribiv ;
PFNGLISPROGRAMPROC glIsProgram ;
PFNGLISSHADERPROC glIsShader ;
PFNGLLINKPROGRAMPROC glLinkProgram ;
PFNGLSHADERSOURCEPROC glShaderSource ;
PFNGLSTENCILFUNCSEPARATEPROC glStencilFuncSeparate ;
PFNGLSTENCILMASKSEPARATEPROC glStencilMaskSeparate ;
PFNGLSTENCILOPSEPARATEPROC glStencilOpSeparate ;
PFNGLUNIFORM1FPROC glUniform1f ;
PFNGLUNIFORM1FVPROC glUniform1fv ;
PFNGLUNIFORM1IPROC glUniform1i ;
PFNGLUNIFORM1IVPROC glUniform1iv ;
PFNGLUNIFORM2FPROC glUniform2f ;
PFNGLUNIFORM2FVPROC glUniform2fv ;
PFNGLUNIFORM2IPROC glUniform2i ;
PFNGLUNIFORM2IVPROC glUniform2iv ;
PFNGLUNIFORM3FPROC glUniform3f ;
PFNGLUNIFORM3FVPROC glUniform3fv ;
PFNGLUNIFORM3IPROC glUniform3i ;
PFNGLUNIFORM3IVPROC glUniform3iv ;
PFNGLUNIFORM4FPROC glUniform4f ;
PFNGLUNIFORM4FVPROC glUniform4fv ;
PFNGLUNIFORM4IPROC glUniform4i ;
PFNGLUNIFORM4IVPROC glUniform4iv ;
PFNGLUNIFORMMATRIX2FVPROC glUniformMatrix2fv ;
PFNGLUNIFORMMATRIX3FVPROC glUniformMatrix3fv ;
PFNGLUNIFORMMATRIX4FVPROC glUniformMatrix4fv ;
PFNGLUSEPROGRAMPROC glUseProgram ;
PFNGLVALIDATEPROGRAMPROC glValidateProgram ;
PFNGLVERTEXATTRIB1DPROC glVertexAttrib1d ;
PFNGLVERTEXATTRIB1DVPROC glVertexAttrib1dv ;
PFNGLVERTEXATTRIB1FPROC glVertexAttrib1f ;
PFNGLVERTEXATTRIB1FVPROC glVertexAttrib1fv ;
PFNGLVERTEXATTRIB1SPROC glVertexAttrib1s ;
PFNGLVERTEXATTRIB1SVPROC glVertexAttrib1sv ;
PFNGLVERTEXATTRIB2DPROC glVertexAttrib2d ;
PFNGLVERTEXATTRIB2DVPROC glVertexAttrib2dv ;
PFNGLVERTEXATTRIB2FPROC glVertexAttrib2f ;
PFNGLVERTEXATTRIB2FVPROC glVertexAttrib2fv ;
PFNGLVERTEXATTRIB2SPROC glVertexAttrib2s ;
PFNGLVERTEXATTRIB2SVPROC glVertexAttrib2sv ;
PFNGLVERTEXATTRIB3DPROC glVertexAttrib3d ;
PFNGLVERTEXATTRIB3DVPROC glVertexAttrib3dv ;
PFNGLVERTEXATTRIB3FPROC glVertexAttrib3f ;
PFNGLVERTEXATTRIB3FVPROC glVertexAttrib3fv ;
PFNGLVERTEXATTRIB3SPROC glVertexAttrib3s ;
PFNGLVERTEXATTRIB3SVPROC glVertexAttrib3sv ;
PFNGLVERTEXATTRIB4NBVPROC glVertexAttrib4Nbv ;
PFNGLVERTEXATTRIB4NIVPROC glVertexAttrib4Niv ;
PFNGLVERTEXATTRIB4NSVPROC glVertexAttrib4Nsv ;
PFNGLVERTEXATTRIB4NUBPROC glVertexAttrib4Nub ;
PFNGLVERTEXATTRIB4NUBVPROC glVertexAttrib4Nubv ;
PFNGLVERTEXATTRIB4NUIVPROC glVertexAttrib4Nuiv ;
PFNGLVERTEXATTRIB4NUSVPROC glVertexAttrib4Nusv ;
PFNGLVERTEXATTRIB4BVPROC glVertexAttrib4bv ;
PFNGLVERTEXATTRIB4DPROC glVertexAttrib4d ;
PFNGLVERTEXATTRIB4DVPROC glVertexAttrib4dv ;
PFNGLVERTEXATTRIB4FPROC glVertexAttrib4f ;
PFNGLVERTEXATTRIB4FVPROC glVertexAttrib4fv ;
PFNGLVERTEXATTRIB4IVPROC glVertexAttrib4iv ;
PFNGLVERTEXATTRIB4SPROC glVertexAttrib4s ;
PFNGLVERTEXATTRIB4SVPROC glVertexAttrib4sv ;
PFNGLVERTEXATTRIB4UBVPROC glVertexAttrib4ubv ;
PFNGLVERTEXATTRIB4UIVPROC glVertexAttrib4uiv ;
PFNGLVERTEXATTRIB4USVPROC glVertexAttrib4usv ;
PFNGLVERTEXATTRIBPOINTERPROC glVertexAttribPointer ;
}

/* ----------------------------- GL_VERSION_2_1 ---------------------------- */
const uint GL_CURRENT_RASTER_SECONDARY_COLOR = 0x845F ;
const uint GL_PIXEL_PACK_BUFFER              = 0x88EB ;
const uint GL_PIXEL_UNPACK_BUFFER            = 0x88EC ;
const uint GL_PIXEL_PACK_BUFFER_BINDING      = 0x88ED ;
const uint GL_PIXEL_UNPACK_BUFFER_BINDING    = 0x88EF ;
const uint GL_FLOAT_MAT2x3                   = 0x8B65 ;
const uint GL_FLOAT_MAT2x4                   = 0x8B66 ;
const uint GL_FLOAT_MAT3x2                   = 0x8B67 ;
const uint GL_FLOAT_MAT3x4                   = 0x8B68 ;
const uint GL_FLOAT_MAT4x2                   = 0x8B69 ;
const uint GL_FLOAT_MAT4x3                   = 0x8B6A ;
const uint GL_SRGB                           = 0x8C40 ;
const uint GL_SRGB8                          = 0x8C41 ;
const uint GL_SRGB_ALPHA                     = 0x8C42 ;
const uint GL_SRGB8_ALPHA8                   = 0x8C43 ;
const uint GL_SLUMINANCE_ALPHA               = 0x8C44 ;
const uint GL_SLUMINANCE8_ALPHA8             = 0x8C45 ;
const uint GL_SLUMINANCE                     = 0x8C46 ;
const uint GL_SLUMINANCE8                    = 0x8C47 ;
const uint GL_COMPRESSED_SRGB                = 0x8C48 ;
const uint GL_COMPRESSED_SRGB_ALPHA          = 0x8C49 ;
const uint GL_COMPRESSED_SLUMINANCE          = 0x8C4A ;
const uint GL_COMPRESSED_SLUMINANCE_ALPHA    = 0x8C4B ;

extern(Windows){
alias void function(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value) PFNGLUNIFORMMATRIX2X3FVPROC ;
alias void function(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value) PFNGLUNIFORMMATRIX2X4FVPROC ;
alias void function(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value) PFNGLUNIFORMMATRIX3X2FVPROC ;
alias void function(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value) PFNGLUNIFORMMATRIX3X4FVPROC ;
alias void function(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value) PFNGLUNIFORMMATRIX4X2FVPROC ;
alias void function(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value) PFNGLUNIFORMMATRIX4X3FVPROC ;

PFNGLUNIFORMMATRIX2X3FVPROC glUniformMatrix2x3fv ;
PFNGLUNIFORMMATRIX2X4FVPROC glUniformMatrix2x4fv ;
PFNGLUNIFORMMATRIX3X2FVPROC glUniformMatrix3x2fv ;
PFNGLUNIFORMMATRIX3X4FVPROC glUniformMatrix3x4fv ;
PFNGLUNIFORMMATRIX4X2FVPROC glUniformMatrix4x2fv ;
PFNGLUNIFORMMATRIX4X3FVPROC glUniformMatrix4x3fv ;
}

/*-------------------------------------------------------------*/
//import win32frame.glut;

/* StringName */
const uint GLU_VERSION                      =  100800 ;
const uint GLU_EXTENSIONS                   =  100801 ;

/* ErrorCode */
const uint GLU_INVALID_ENUM                 =  100900 ;
const uint GLU_INVALID_VALUE                =  100901 ;
const uint GLU_OUT_OF_MEMORY                =  100902 ;
const uint GLU_INVALID_OPERATION            =  100904 ;

/* NurbsDisplay */
/*      GLU_FILL */
const uint GLU_OUTLINE_POLYGON              =  100240 ;
const uint GLU_OUTLINE_PATCH                =  100241 ;

/* NurbsError */
const uint GLU_NURBS_ERROR1                 =  100251 ;
const uint GLU_NURBS_ERROR2                 =  100252 ;
const uint GLU_NURBS_ERROR3                 =  100253 ;
const uint GLU_NURBS_ERROR4                 =  100254 ;
const uint GLU_NURBS_ERROR5                 =  100255 ;
const uint GLU_NURBS_ERROR6                 =  100256 ;
const uint GLU_NURBS_ERROR7                 =  100257 ;
const uint GLU_NURBS_ERROR8                 =  100258 ;
const uint GLU_NURBS_ERROR9                 =  100259 ;
const uint GLU_NURBS_ERROR10                =  100260 ;
const uint GLU_NURBS_ERROR11                =  100261 ;
const uint GLU_NURBS_ERROR12                =  100262 ;
const uint GLU_NURBS_ERROR13                =  100263 ;
const uint GLU_NURBS_ERROR14                =  100264 ;
const uint GLU_NURBS_ERROR15                =  100265 ;
const uint GLU_NURBS_ERROR16                =  100266 ;
const uint GLU_NURBS_ERROR17                =  100267 ;
const uint GLU_NURBS_ERROR18                =  100268 ;
const uint GLU_NURBS_ERROR19                =  100269 ;
const uint GLU_NURBS_ERROR20                =  100270 ;
const uint GLU_NURBS_ERROR21                =  100271 ;
const uint GLU_NURBS_ERROR22                =  100272 ;
const uint GLU_NURBS_ERROR23                =  100273 ;
const uint GLU_NURBS_ERROR24                =  100274 ;
const uint GLU_NURBS_ERROR25                =  100275 ;
const uint GLU_NURBS_ERROR26                =  100276 ;
const uint GLU_NURBS_ERROR27                =  100277 ;
const uint GLU_NURBS_ERROR28                =  100278 ;
const uint GLU_NURBS_ERROR29                =  100279 ;
const uint GLU_NURBS_ERROR30                =  100280 ;
const uint GLU_NURBS_ERROR31                =  100281 ;
const uint GLU_NURBS_ERROR32                =  100282 ;
const uint GLU_NURBS_ERROR33                =  100283 ;
const uint GLU_NURBS_ERROR34                =  100284 ;
const uint GLU_NURBS_ERROR35                =  100285 ;
const uint GLU_NURBS_ERROR36                =  100286 ;
const uint GLU_NURBS_ERROR37                =  100287 ;

/* NurbsProperty */
const uint GLU_AUTO_LOAD_MATRIX             =  100200 ;
const uint GLU_CULLING                      =  100201 ;
const uint GLU_SAMPLING_TOLERANCE           =  100203 ;
const uint GLU_DISPLAY_MODE                 =  100204 ;
const uint GLU_PARAMETRIC_TOLERANCE         =  100202 ;
const uint GLU_SAMPLING_METHOD              =  100205 ;
const uint GLU_U_STEP                       =  100206 ;
const uint GLU_V_STEP                       =  100207 ;

/* NurbsSampling */
const uint GLU_PATH_LENGTH                  =  100215 ;
const uint GLU_PARAMETRIC_ERROR             =  100216 ;
const uint GLU_DOMAIN_DISTANCE              =  100217 ;

/* NurbsTrim */
const uint GLU_MAP1_TRIM_2                  =  100210 ;
const uint GLU_MAP1_TRIM_3                  =  100211 ;

/* QuadricDrawStyle */
const uint GLU_POINT                        =  100010 ;
const uint GLU_LINE                         =  100011 ;
const uint GLU_FILL                         =  100012 ;
const uint GLU_SILHOUETTE                   =  100013 ;

/* QuadricCallback */
const uint GLU_ERROR                        =  100103 ;

/* QuadricNormal */
const uint GLU_SMOOTH                       =  100000 ;
const uint GLU_FLAT                         =  100001 ;
const uint GLU_NONE                         =  100002 ;

/* QuadricOrientation */
const uint GLU_OUTSIDE                      =  100020 ;
const uint GLU_INSIDE                       =  100021 ;

/* TessCallback */
const uint GLU_TESS_BEGIN                   =  100100 ;
const uint GLU_BEGIN                        =  100100 ;
const uint GLU_TESS_VERTEX                  =  100101 ;
const uint GLU_VERTEX                       =  100101 ;
const uint GLU_TESS_END                     =  100102 ;
const uint GLU_END                          =  100102 ;
const uint GLU_TESS_ERROR                   =  100103 ;
const uint GLU_TESS_EDGE_FLAG               =  100104 ;
const uint GLU_EDGE_FLAG                    =  100104 ;
const uint GLU_TESS_COMBINE                 =  100105 ;
const uint GLU_TESS_BEGIN_DATA              =  100106 ;
const uint GLU_TESS_VERTEX_DATA             =  100107 ;
const uint GLU_TESS_END_DATA                =  100108 ;
const uint GLU_TESS_ERROR_DATA              =  100109 ;
const uint GLU_TESS_EDGE_FLAG_DATA          =  100110 ;
const uint GLU_TESS_COMBINE_DATA            =  100111 ;

/* TessContour */
const uint GLU_CW                           =  100120 ;
const uint GLU_CCW                          =  100121 ;
const uint GLU_INTERIOR                     =  100122 ;
const uint GLU_EXTERIOR                     =  100123 ;
const uint GLU_UNKNOWN                      =  100124 ;

/* TessProperty */
const uint GLU_TESS_WINDING_RULE            =  100140 ;
const uint GLU_TESS_BOUNDARY_ONLY           =  100141 ;
const uint GLU_TESS_TOLERANCE               =  100142 ;

/* TessError */
const uint GLU_TESS_ERROR1                  =  100151 ;
const uint GLU_TESS_ERROR2                  =  100152 ;
const uint GLU_TESS_ERROR3                  =  100153 ;
const uint GLU_TESS_ERROR4                  =  100154 ;
const uint GLU_TESS_ERROR5                  =  100155 ;
const uint GLU_TESS_ERROR6                  =  100156 ;
const uint GLU_TESS_ERROR7                  =  100157 ;
const uint GLU_TESS_ERROR8                  =  100158 ;
const uint GLU_TESS_MISSING_BEGIN_POLYGON   =  100151 ;
const uint GLU_TESS_MISSING_BEGIN_CONTOUR   =  100152 ;
const uint GLU_TESS_MISSING_END_POLYGON     =  100153 ;
const uint GLU_TESS_MISSING_END_CONTOUR     =  100154 ;
const uint GLU_TESS_COORD_TOO_LARGE         =  100155 ;
const uint GLU_TESS_NEED_COMBINE_CALLBACK   =  100156 ;

/* TessWinding */
const uint GLU_TESS_WINDING_ODD             =  100130 ;
const uint GLU_TESS_WINDING_NONZERO         =  100131 ;
const uint GLU_TESS_WINDING_POSITIVE        =  100132 ;
const uint GLU_TESS_WINDING_NEGATIVE        =  100133 ;
const uint GLU_TESS_WINDING_ABS_GEQ_TWO     =  100134 ;

/* Obsolete. For compatibility with previous Sun OpenGL versions */
const uint GLU_INCOMPATIBLE_GL_VERSION      =  100903 ;


/*************************************************************/



int glextInit()
{
  int ret=0x00001000;
  
  /* ----------------------------- GL_VERSION_1_2 ---------------------------- */
  if( (glCopyTexSubImage3D = cast(PFNGLCOPYTEXSUBIMAGE3DPROC)wglGetProcAddress( cast(char*)("glCopyTexSubImage3D") ) )!=null &&
      (glDrawRangeElements = cast(PFNGLDRAWRANGEELEMENTSPROC)wglGetProcAddress( cast(char*)("glDrawRangeElements") ) )!=null &&
      (glTexImage3D = cast(PFNGLTEXIMAGE3DPROC)wglGetProcAddress( cast(char*)("glTexImage3D") ) )!=null &&
      (glTexSubImage3D = cast(PFNGLTEXSUBIMAGE3DPROC)wglGetProcAddress( cast(char*)("glTexSubImage3D") ) )!=null )
    {
      writek("accept GL_VERSION 1.2\n") ;
      ret=0x00001200;
    }else{
      writek("not accept GL_VERSION 1.2\n") ;
  }    
    

  /* ----------------------------- GL_VERSION_1_3 ---------------------------- */
  if( (glActiveTexture = cast(PFNGLACTIVETEXTUREPROC)wglGetProcAddress( cast(char*)("glActiveTexture") ) )!=null &&
      (glClientActiveTexture = cast(PFNGLCLIENTACTIVETEXTUREPROC)wglGetProcAddress( cast(char*)("glClientActiveTexture") ) )!=null &&
      (glCompressedTexImage1D = cast(PFNGLCOMPRESSEDTEXIMAGE1DPROC)wglGetProcAddress( cast(char*)("glCompressedTexImage1D") ) )!=null &&
      (glCompressedTexImage2D = cast(PFNGLCOMPRESSEDTEXIMAGE2DPROC)wglGetProcAddress( cast(char*)("glCompressedTexImage2D") ) )!=null &&
      (glCompressedTexImage3D = cast(PFNGLCOMPRESSEDTEXIMAGE3DPROC)wglGetProcAddress( cast(char*)("glCompressedTexImage3D") ) )!=null &&
      (glCompressedTexSubImage1D = cast(PFNGLCOMPRESSEDTEXSUBIMAGE1DPROC)wglGetProcAddress( cast(char*)("glCompressedTexSubImage1D") ) )!=null &&
      (glCompressedTexSubImage2D = cast(PFNGLCOMPRESSEDTEXSUBIMAGE2DPROC)wglGetProcAddress( cast(char*)("glCompressedTexSubImage2D") ) )!=null &&
      (glCompressedTexSubImage3D = cast(PFNGLCOMPRESSEDTEXSUBIMAGE3DPROC)wglGetProcAddress( cast(char*)("glCompressedTexSubImage3D") ) )!=null &&
      (glGetCompressedTexImage = cast(PFNGLGETCOMPRESSEDTEXIMAGEPROC)wglGetProcAddress( cast(char*)("glGetCompressedTexImage") ) )!=null &&
      (glLoadTransposeMatrixd = cast(PFNGLLOADTRANSPOSEMATRIXDPROC)wglGetProcAddress( cast(char*)("glLoadTransposeMatrixd") ) )!=null &&
      (glLoadTransposeMatrixf = cast(PFNGLLOADTRANSPOSEMATRIXFPROC)wglGetProcAddress( cast(char*)("glLoadTransposeMatrixf") ) )!=null &&
      (glMultTransposeMatrixd = cast(PFNGLMULTTRANSPOSEMATRIXDPROC)wglGetProcAddress( cast(char*)("glMultTransposeMatrixd") ) )!=null &&
      (glMultTransposeMatrixf = cast(PFNGLMULTTRANSPOSEMATRIXFPROC)wglGetProcAddress( cast(char*)("glMultTransposeMatrixf") ) )!=null &&
      (glMultiTexCoord1d = cast(PFNGLMULTITEXCOORD1DPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord1d") ) )!=null &&
      (glMultiTexCoord1dv = cast(PFNGLMULTITEXCOORD1DVPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord1dv") ) )!=null &&
      (glMultiTexCoord1f = cast(PFNGLMULTITEXCOORD1FPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord1f") ) )!=null &&
      (glMultiTexCoord1fv = cast(PFNGLMULTITEXCOORD1FVPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord1fv") ) )!=null &&
      (glMultiTexCoord1i = cast(PFNGLMULTITEXCOORD1IPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord1i") ) )!=null &&
      (glMultiTexCoord1iv = cast(PFNGLMULTITEXCOORD1IVPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord1iv") ) )!=null &&
      (glMultiTexCoord1s = cast(PFNGLMULTITEXCOORD1SPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord1s") ) )!=null &&
      (glMultiTexCoord1sv = cast(PFNGLMULTITEXCOORD1SVPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord1sv") ) )!=null &&
      (glMultiTexCoord2d = cast(PFNGLMULTITEXCOORD2DPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord2d") ) )!=null &&
      (glMultiTexCoord2dv = cast(PFNGLMULTITEXCOORD2DVPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord2dv") ) )!=null &&
      (glMultiTexCoord2f = cast(PFNGLMULTITEXCOORD2FPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord2f") ) )!=null &&
      (glMultiTexCoord2fv = cast(PFNGLMULTITEXCOORD2FVPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord2fv") ) )!=null &&
      (glMultiTexCoord2i = cast(PFNGLMULTITEXCOORD2IPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord2i") ) )!=null &&
      (glMultiTexCoord2iv = cast(PFNGLMULTITEXCOORD2IVPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord2iv") ) )!=null &&
      (glMultiTexCoord2s = cast(PFNGLMULTITEXCOORD2SPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord2s") ) )!=null &&
      (glMultiTexCoord2sv = cast(PFNGLMULTITEXCOORD2SVPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord2sv") ) )!=null &&
      (glMultiTexCoord3d = cast(PFNGLMULTITEXCOORD3DPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord3d") ) )!=null &&
      (glMultiTexCoord3dv = cast(PFNGLMULTITEXCOORD3DVPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord3dv") ) )!=null &&
      (glMultiTexCoord3f = cast(PFNGLMULTITEXCOORD3FPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord3f") ) )!=null &&
      (glMultiTexCoord3fv = cast(PFNGLMULTITEXCOORD3FVPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord3fv") ) )!=null &&
      (glMultiTexCoord3i = cast(PFNGLMULTITEXCOORD3IPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord3i") ) )!=null &&
      (glMultiTexCoord3iv = cast(PFNGLMULTITEXCOORD3IVPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord3iv") ) )!=null &&
      (glMultiTexCoord3s = cast(PFNGLMULTITEXCOORD3SPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord3s") ) )!=null &&
      (glMultiTexCoord3sv = cast(PFNGLMULTITEXCOORD3SVPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord3sv") ) )!=null &&
      (glMultiTexCoord4d = cast(PFNGLMULTITEXCOORD4DPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord4d") ) )!=null &&
      (glMultiTexCoord4dv = cast(PFNGLMULTITEXCOORD4DVPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord4dv") ) )!=null &&
      (glMultiTexCoord4f = cast(PFNGLMULTITEXCOORD4FPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord4f") ) )!=null &&
      (glMultiTexCoord4fv = cast(PFNGLMULTITEXCOORD4FVPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord4fv") ) )!=null &&
      (glMultiTexCoord4i = cast(PFNGLMULTITEXCOORD4IPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord4i") ) )!=null &&
      (glMultiTexCoord4iv = cast(PFNGLMULTITEXCOORD4IVPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord4iv") ) )!=null &&
      (glMultiTexCoord4s = cast(PFNGLMULTITEXCOORD4SPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord4s") ) )!=null &&
      (glMultiTexCoord4sv = cast(PFNGLMULTITEXCOORD4SVPROC)wglGetProcAddress( cast(char*)("glMultiTexCoord4sv") ) )!=null &&
      (glSampleCoverage = cast(PFNGLSAMPLECOVERAGEPROC)wglGetProcAddress( cast(char*)("glSampleCoverage") ) )!=null )
    {
      writek("accept GL_VERSION 1.3\n") ;
      ret=0x00001300;
    }else{
      writek("not accept GL_VERSION 1.3\n") ;
  }
    

  /* ----------------------------- GL_VERSION_1_4 ---------------------------- */
  if( (glBlendColor = cast(PFNGLBLENDCOLORPROC)wglGetProcAddress( cast(char*)("glBlendColor") ) )!=null &&
      (glBlendEquation = cast(PFNGLBLENDEQUATIONPROC)wglGetProcAddress( cast(char*)("glBlendEquation") ) )!=null &&
      (glBlendFuncSeparate = cast(PFNGLBLENDFUNCSEPARATEPROC)wglGetProcAddress( cast(char*)("glBlendFuncSeparate") ) )!=null &&
      (glFogCoordPointer = cast(PFNGLFOGCOORDPOINTERPROC)wglGetProcAddress( cast(char*)("glFogCoordPointer") ) )!=null &&
      (glFogCoordd = cast(PFNGLFOGCOORDDPROC)wglGetProcAddress( cast(char*)("glFogCoordd") ) )!=null &&
      (glFogCoorddv = cast(PFNGLFOGCOORDDVPROC)wglGetProcAddress( cast(char*)("glFogCoorddv") ) )!=null &&
      (glFogCoordf = cast(PFNGLFOGCOORDFPROC)wglGetProcAddress( cast(char*)("glFogCoordf") ) )!=null &&
      (glFogCoordfv = cast(PFNGLFOGCOORDFVPROC)wglGetProcAddress( cast(char*)("glFogCoordfv") ) )!=null &&
      (glMultiDrawArrays = cast(PFNGLMULTIDRAWARRAYSPROC)wglGetProcAddress( cast(char*)("glMultiDrawArrays") ) )!=null &&
      (glMultiDrawElements = cast(PFNGLMULTIDRAWELEMENTSPROC)wglGetProcAddress( cast(char*)("glMultiDrawElements") ) )!=null &&
      (glPointParameterf = cast(PFNGLPOINTPARAMETERFPROC)wglGetProcAddress( cast(char*)("glPointParameterf") ) )!=null &&
      (glPointParameterfv = cast(PFNGLPOINTPARAMETERFVPROC)wglGetProcAddress( cast(char*)("glPointParameterfv") ) )!=null &&
      (glPointParameteri = cast(PFNGLPOINTPARAMETERIPROC)wglGetProcAddress( cast(char*)("glPointParameteri") ) )!=null &&
      (glPointParameteriv = cast(PFNGLPOINTPARAMETERIVPROC)wglGetProcAddress( cast(char*)("glPointParameteriv") ) )!=null &&
      (glSecondaryColor3b = cast(PFNGLSECONDARYCOLOR3BPROC)wglGetProcAddress( cast(char*)("glSecondaryColor3b") ) )!=null &&
      (glSecondaryColor3bv = cast(PFNGLSECONDARYCOLOR3BVPROC)wglGetProcAddress( cast(char*)("glSecondaryColor3bv") ) )!=null &&
      (glSecondaryColor3d = cast(PFNGLSECONDARYCOLOR3DPROC)wglGetProcAddress( cast(char*)("glSecondaryColor3d") ) )!=null &&
      (glSecondaryColor3dv = cast(PFNGLSECONDARYCOLOR3DVPROC)wglGetProcAddress( cast(char*)("glSecondaryColor3dv") ) )!=null &&
      (glSecondaryColor3f = cast(PFNGLSECONDARYCOLOR3FPROC)wglGetProcAddress( cast(char*)("glSecondaryColor3f") ) )!=null &&
      (glSecondaryColor3fv = cast(PFNGLSECONDARYCOLOR3FVPROC)wglGetProcAddress( cast(char*)("glSecondaryColor3fv") ) )!=null &&
      (glSecondaryColor3i = cast(PFNGLSECONDARYCOLOR3IPROC)wglGetProcAddress( cast(char*)("glSecondaryColor3i") ) )!=null &&
      (glSecondaryColor3iv = cast(PFNGLSECONDARYCOLOR3IVPROC)wglGetProcAddress( cast(char*)("glSecondaryColor3iv") ) )!=null &&
      (glSecondaryColor3s = cast(PFNGLSECONDARYCOLOR3SPROC)wglGetProcAddress( cast(char*)("glSecondaryColor3s") ) )!=null &&
      (glSecondaryColor3sv = cast(PFNGLSECONDARYCOLOR3SVPROC)wglGetProcAddress( cast(char*)("glSecondaryColor3sv") ) )!=null &&
      (glSecondaryColor3ub = cast(PFNGLSECONDARYCOLOR3UBPROC)wglGetProcAddress( cast(char*)("glSecondaryColor3ub") ) )!=null &&
      (glSecondaryColor3ubv = cast(PFNGLSECONDARYCOLOR3UBVPROC)wglGetProcAddress( cast(char*)("glSecondaryColor3ubv") ) )!=null &&
      (glSecondaryColor3ui = cast(PFNGLSECONDARYCOLOR3UIPROC)wglGetProcAddress( cast(char*)("glSecondaryColor3ui") ) )!=null &&
      (glSecondaryColor3uiv = cast(PFNGLSECONDARYCOLOR3UIVPROC)wglGetProcAddress( cast(char*)("glSecondaryColor3uiv") ) )!=null &&
      (glSecondaryColor3us = cast(PFNGLSECONDARYCOLOR3USPROC)wglGetProcAddress( cast(char*)("glSecondaryColor3us") ) )!=null &&
      (glSecondaryColor3usv = cast(PFNGLSECONDARYCOLOR3USVPROC)wglGetProcAddress( cast(char*)("glSecondaryColor3usv") ) )!=null &&
      (glSecondaryColorPointer = cast(PFNGLSECONDARYCOLORPOINTERPROC)wglGetProcAddress( cast(char*)("glSecondaryColorPointer") ) )!=null &&
      (glWindowPos2d = cast(PFNGLWINDOWPOS2DPROC)wglGetProcAddress( cast(char*)("glWindowPos2d") ) )!=null &&
      (glWindowPos2dv = cast(PFNGLWINDOWPOS2DVPROC)wglGetProcAddress( cast(char*)("glWindowPos2dv") ) )!=null &&
      (glWindowPos2f = cast(PFNGLWINDOWPOS2FPROC)wglGetProcAddress( cast(char*)("glWindowPos2f") ) )!=null &&
      (glWindowPos2fv = cast(PFNGLWINDOWPOS2FVPROC)wglGetProcAddress( cast(char*)("glWindowPos2fv") ) )!=null &&
      (glWindowPos2i = cast(PFNGLWINDOWPOS2IPROC)wglGetProcAddress( cast(char*)("glWindowPos2i") ) )!=null &&
      (glWindowPos2iv = cast(PFNGLWINDOWPOS2IVPROC)wglGetProcAddress( cast(char*)("glWindowPos2iv") ) )!=null &&
      (glWindowPos2s = cast(PFNGLWINDOWPOS2SPROC)wglGetProcAddress( cast(char*)("glWindowPos2s") ) )!=null &&
      (glWindowPos2sv = cast(PFNGLWINDOWPOS2SVPROC)wglGetProcAddress( cast(char*)("glWindowPos2sv") ) )!=null &&
      (glWindowPos3d = cast(PFNGLWINDOWPOS3DPROC)wglGetProcAddress( cast(char*)("glWindowPos3d") ) )!=null &&
      (glWindowPos3dv = cast(PFNGLWINDOWPOS3DVPROC)wglGetProcAddress( cast(char*)("glWindowPos3dv") ) )!=null &&
      (glWindowPos3f = cast(PFNGLWINDOWPOS3FPROC)wglGetProcAddress( cast(char*)("glWindowPos3f") ) )!=null &&
      (glWindowPos3fv = cast(PFNGLWINDOWPOS3FVPROC)wglGetProcAddress( cast(char*)("glWindowPos3fv") ) )!=null &&
      (glWindowPos3i = cast(PFNGLWINDOWPOS3IPROC)wglGetProcAddress( cast(char*)("glWindowPos3i") ) )!=null &&
      (glWindowPos3iv = cast(PFNGLWINDOWPOS3IVPROC)wglGetProcAddress( cast(char*)("glWindowPos3iv") ) )!=null &&
      (glWindowPos3s = cast(PFNGLWINDOWPOS3SPROC)wglGetProcAddress( cast(char*)("glWindowPos3s") ) )!=null &&
      (glWindowPos3sv = cast(PFNGLWINDOWPOS3SVPROC)wglGetProcAddress( cast(char*)("glWindowPos3sv") ) )!=null )
    {
      writek("accept GL_VERSION 1.4\n") ;
      ret=0x00001400;
    }else{
      writek("not accept GL_VERSION 1.4\n") ;
  }
      

  /* ----------------------------- GL_VERSION_1_5 ---------------------------- */
  if( (glBeginQuery = cast(PFNGLBEGINQUERYPROC)wglGetProcAddress( cast(char*)("glBeginQuery") ) )!=null &&
      (glBindBuffer = cast(PFNGLBINDBUFFERPROC)wglGetProcAddress( cast(char*)("glBindBuffer") ) )!=null &&
      (glBufferData = cast(PFNGLBUFFERDATAPROC)wglGetProcAddress( cast(char*)("glBufferData") ) )!=null &&
      (glBufferSubData = cast(PFNGLBUFFERSUBDATAPROC)wglGetProcAddress( cast(char*)("glBufferSubData") ) )!=null &&
      (glDeleteBuffers = cast(PFNGLDELETEBUFFERSPROC)wglGetProcAddress( cast(char*)("glDeleteBuffers") ) )!=null &&
      (glDeleteQueries = cast(PFNGLDELETEQUERIESPROC)wglGetProcAddress( cast(char*)("glDeleteQueries") ) )!=null &&
      (glEndQuery = cast(PFNGLENDQUERYPROC)wglGetProcAddress( cast(char*)("glEndQuery") ) )!=null &&
      (glGenBuffers = cast(PFNGLGENBUFFERSPROC)wglGetProcAddress( cast(char*)("glGenBuffers") ) )!=null &&
      (glGenQueries = cast(PFNGLGENQUERIESPROC)wglGetProcAddress( cast(char*)("glGenQueries") ) )!=null &&
      (glGetBufferParameteriv = cast(PFNGLGETBUFFERPARAMETERIVPROC)wglGetProcAddress( cast(char*)("glGetBufferParameteriv") ) )!=null &&
      (glGetBufferPointerv = cast(PFNGLGETBUFFERPOINTERVPROC)wglGetProcAddress( cast(char*)("glGetBufferPointerv") ) )!=null &&
      (glGetBufferSubData = cast(PFNGLGETBUFFERSUBDATAPROC)wglGetProcAddress( cast(char*)("glGetBufferSubData") ) )!=null &&
      (glGetQueryObjectiv = cast(PFNGLGETQUERYOBJECTIVPROC)wglGetProcAddress( cast(char*)("glGetQueryObjectiv") ) )!=null &&
      (glGetQueryObjectuiv = cast(PFNGLGETQUERYOBJECTUIVPROC)wglGetProcAddress( cast(char*)("glGetQueryObjectuiv") ) )!=null &&
      (glGetQueryiv = cast(PFNGLGETQUERYIVPROC)wglGetProcAddress( cast(char*)("glGetQueryiv") ) )!=null &&
      (glIsBuffer = cast(PFNGLISBUFFERPROC)wglGetProcAddress( cast(char*)("glIsBuffer") ) )!=null &&
      (glIsQuery = cast(PFNGLISQUERYPROC)wglGetProcAddress( cast(char*)("glIsQuery") ) )!=null &&
      (glMapBuffer = cast(PFNGLMAPBUFFERPROC)wglGetProcAddress( cast(char*)("glMapBuffer") ) )!=null &&
      (glUnmapBuffer = cast(PFNGLUNMAPBUFFERPROC)wglGetProcAddress( cast(char*)("glUnmapBuffer") ) )!=null )
    {
      writek("accept GL_VERSION 1.5\n") ;
      ret=0x00001500;
    }else{
      writek("not accept GL_VERSION 1.5\n") ;
  }
    

  /* ----------------------------- GL_VERSION_2_0 ---------------------------- */
  if( (glAttachShader = cast(PFNGLATTACHSHADERPROC)wglGetProcAddress( cast(char*)("glAttachShader") ) )!=null &&
      (glBindAttribLocation = cast(PFNGLBINDATTRIBLOCATIONPROC)wglGetProcAddress( cast(char*)("glBindAttribLocation") ) )!=null &&
      (glBlendEquationSeparate = cast(PFNGLBLENDEQUATIONSEPARATEPROC)wglGetProcAddress( cast(char*)("glBlendEquationSeparate") ) )!=null &&
      (glCompileShader = cast(PFNGLCOMPILESHADERPROC)wglGetProcAddress( cast(char*)("glCompileShader") ) )!=null &&
      (glCreateProgram = cast(PFNGLCREATEPROGRAMPROC)wglGetProcAddress( cast(char*)("glCreateProgram") ) )!=null &&
      (glCreateShader = cast(PFNGLCREATESHADERPROC)wglGetProcAddress( cast(char*)("glCreateShader") ) )!=null &&
      (glDeleteProgram = cast(PFNGLDELETEPROGRAMPROC)wglGetProcAddress( cast(char*)("glDeleteProgram") ) )!=null &&
      (glDeleteShader = cast(PFNGLDELETESHADERPROC)wglGetProcAddress( cast(char*)("glDeleteShader") ) )!=null &&
      (glDetachShader = cast(PFNGLDETACHSHADERPROC)wglGetProcAddress( cast(char*)("glDetachShader") ) )!=null &&
      (glDisableVertexAttribArray = cast(PFNGLDISABLEVERTEXATTRIBARRAYPROC)wglGetProcAddress( cast(char*)("glDisableVertexAttribArray") ) )!=null &&
      (glDrawBuffers = cast(PFNGLDRAWBUFFERSPROC)wglGetProcAddress( cast(char*)("glDrawBuffers") ) )!=null &&
      (glEnableVertexAttribArray = cast(PFNGLENABLEVERTEXATTRIBARRAYPROC)wglGetProcAddress( cast(char*)("glEnableVertexAttribArray") ) )!=null &&
      (glGetActiveAttrib = cast(PFNGLGETACTIVEATTRIBPROC)wglGetProcAddress( cast(char*)("glGetActiveAttrib") ) )!=null &&
      (glGetActiveUniform = cast(PFNGLGETACTIVEUNIFORMPROC)wglGetProcAddress( cast(char*)("glGetActiveUniform") ) )!=null &&
      (glGetAttachedShaders = cast(PFNGLGETATTACHEDSHADERSPROC)wglGetProcAddress( cast(char*)("glGetAttachedShaders") ) )!=null &&
      (glGetAttribLocation = cast(PFNGLGETATTRIBLOCATIONPROC)wglGetProcAddress( cast(char*)("glGetAttribLocation") ) )!=null &&
      (glGetProgramInfoLog = cast(PFNGLGETPROGRAMINFOLOGPROC)wglGetProcAddress( cast(char*)("glGetProgramInfoLog") ) )!=null &&
      (glGetProgramiv = cast(PFNGLGETPROGRAMIVPROC)wglGetProcAddress( cast(char*)("glGetProgramiv") ) )!=null &&
      (glGetShaderInfoLog = cast(PFNGLGETSHADERINFOLOGPROC)wglGetProcAddress( cast(char*)("glGetShaderInfoLog") ) )!=null &&
      (glGetShaderSource = cast(PFNGLGETSHADERSOURCEPROC)wglGetProcAddress( cast(char*)("glGetShaderSource") ) )!=null &&
      (glGetShaderiv = cast(PFNGLGETSHADERIVPROC)wglGetProcAddress( cast(char*)("glGetShaderiv") ) )!=null &&
      (glGetUniformLocation = cast(PFNGLGETUNIFORMLOCATIONPROC)wglGetProcAddress( cast(char*)("glGetUniformLocation") ) )!=null &&
      (glGetUniformfv = cast(PFNGLGETUNIFORMFVPROC)wglGetProcAddress( cast(char*)("glGetUniformfv") ) )!=null &&
      (glGetUniformiv = cast(PFNGLGETUNIFORMIVPROC)wglGetProcAddress( cast(char*)("glGetUniformiv") ) )!=null &&
      (glGetVertexAttribPointerv = cast(PFNGLGETVERTEXATTRIBPOINTERVPROC)wglGetProcAddress( cast(char*)("glGetVertexAttribPointerv") ) )!=null &&
      (glGetVertexAttribdv = cast(PFNGLGETVERTEXATTRIBDVPROC)wglGetProcAddress( cast(char*)("glGetVertexAttribdv") ) )!=null &&
      (glGetVertexAttribfv = cast(PFNGLGETVERTEXATTRIBFVPROC)wglGetProcAddress( cast(char*)("glGetVertexAttribfv") ) )!=null &&
      (glGetVertexAttribiv = cast(PFNGLGETVERTEXATTRIBIVPROC)wglGetProcAddress( cast(char*)("glGetVertexAttribiv") ) )!=null &&
      (glIsProgram = cast(PFNGLISPROGRAMPROC)wglGetProcAddress( cast(char*)("glIsProgram") ) )!=null &&
      (glIsShader = cast(PFNGLISSHADERPROC)wglGetProcAddress( cast(char*)("glIsShader") ) )!=null &&
      (glLinkProgram = cast(PFNGLLINKPROGRAMPROC)wglGetProcAddress( cast(char*)("glLinkProgram") ) )!=null &&
      (glShaderSource = cast(PFNGLSHADERSOURCEPROC)wglGetProcAddress( cast(char*)("glShaderSource") ) )!=null &&
      (glStencilFuncSeparate = cast(PFNGLSTENCILFUNCSEPARATEPROC)wglGetProcAddress( cast(char*)("glStencilFuncSeparate") ) )!=null &&
      (glStencilMaskSeparate = cast(PFNGLSTENCILMASKSEPARATEPROC)wglGetProcAddress( cast(char*)("glStencilMaskSeparate") ) )!=null &&
      (glStencilOpSeparate = cast(PFNGLSTENCILOPSEPARATEPROC)wglGetProcAddress( cast(char*)("glStencilOpSeparate") ) )!=null &&
      (glUniform1f = cast(PFNGLUNIFORM1FPROC)wglGetProcAddress( cast(char*)("glUniform1f") ) )!=null &&
      (glUniform1fv = cast(PFNGLUNIFORM1FVPROC)wglGetProcAddress( cast(char*)("glUniform1fv") ) )!=null &&
      (glUniform1i = cast(PFNGLUNIFORM1IPROC)wglGetProcAddress( cast(char*)("glUniform1i") ) )!=null &&
      (glUniform1iv = cast(PFNGLUNIFORM1IVPROC)wglGetProcAddress( cast(char*)("glUniform1iv") ) )!=null &&
      (glUniform2f = cast(PFNGLUNIFORM2FPROC)wglGetProcAddress( cast(char*)("glUniform2f") ) )!=null &&
      (glUniform2fv = cast(PFNGLUNIFORM2FVPROC)wglGetProcAddress( cast(char*)("glUniform2fv") ) )!=null &&
      (glUniform2i = cast(PFNGLUNIFORM2IPROC)wglGetProcAddress( cast(char*)("glUniform2i") ) )!=null &&
      (glUniform2iv = cast(PFNGLUNIFORM2IVPROC)wglGetProcAddress( cast(char*)("glUniform2iv") ) )!=null &&
      (glUniform3f = cast(PFNGLUNIFORM3FPROC)wglGetProcAddress( cast(char*)("glUniform3f") ) )!=null &&
      (glUniform3fv = cast(PFNGLUNIFORM3FVPROC)wglGetProcAddress( cast(char*)("glUniform3fv") ) )!=null &&
      (glUniform3i = cast(PFNGLUNIFORM3IPROC)wglGetProcAddress( cast(char*)("glUniform3i") ) )!=null &&
      (glUniform3iv = cast(PFNGLUNIFORM3IVPROC)wglGetProcAddress( cast(char*)("glUniform3iv") ) )!=null &&
      (glUniform4f = cast(PFNGLUNIFORM4FPROC)wglGetProcAddress( cast(char*)("glUniform4f") ) )!=null &&
      (glUniform4fv = cast(PFNGLUNIFORM4FVPROC)wglGetProcAddress( cast(char*)("glUniform4fv") ) )!=null &&
      (glUniform4i = cast(PFNGLUNIFORM4IPROC)wglGetProcAddress( cast(char*)("glUniform4i") ) )!=null &&
      (glUniform4iv = cast(PFNGLUNIFORM4IVPROC)wglGetProcAddress( cast(char*)("glUniform4iv") ) )!=null &&
      (glUniformMatrix2fv = cast(PFNGLUNIFORMMATRIX2FVPROC)wglGetProcAddress( cast(char*)("glUniformMatrix2fv") ) )!=null &&
      (glUniformMatrix3fv = cast(PFNGLUNIFORMMATRIX3FVPROC)wglGetProcAddress( cast(char*)("glUniformMatrix3fv") ) )!=null &&
      (glUniformMatrix4fv = cast(PFNGLUNIFORMMATRIX4FVPROC)wglGetProcAddress( cast(char*)("glUniformMatrix4fv") ) )!=null &&
      (glUseProgram = cast(PFNGLUSEPROGRAMPROC)wglGetProcAddress( cast(char*)("glUseProgram") ) )!=null &&
      (glValidateProgram = cast(PFNGLVALIDATEPROGRAMPROC)wglGetProcAddress( cast(char*)("glValidateProgram") ) )!=null &&
      (glVertexAttrib1d = cast(PFNGLVERTEXATTRIB1DPROC)wglGetProcAddress( cast(char*)("glVertexAttrib1d") ) )!=null &&
      (glVertexAttrib1dv = cast(PFNGLVERTEXATTRIB1DVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib1dv") ) )!=null &&
      (glVertexAttrib1f = cast(PFNGLVERTEXATTRIB1FPROC)wglGetProcAddress( cast(char*)("glVertexAttrib1f") ) )!=null &&
      (glVertexAttrib1fv = cast(PFNGLVERTEXATTRIB1FVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib1fv") ) )!=null &&
      (glVertexAttrib1s = cast(PFNGLVERTEXATTRIB1SPROC)wglGetProcAddress( cast(char*)("glVertexAttrib1s") ) )!=null &&
      (glVertexAttrib1sv = cast(PFNGLVERTEXATTRIB1SVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib1sv") ) )!=null &&
      (glVertexAttrib2d = cast(PFNGLVERTEXATTRIB2DPROC)wglGetProcAddress( cast(char*)("glVertexAttrib2d") ) )!=null &&
      (glVertexAttrib2dv = cast(PFNGLVERTEXATTRIB2DVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib2dv") ) )!=null &&
      (glVertexAttrib2f = cast(PFNGLVERTEXATTRIB2FPROC)wglGetProcAddress( cast(char*)("glVertexAttrib2f") ) )!=null &&
      (glVertexAttrib2fv = cast(PFNGLVERTEXATTRIB2FVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib2fv") ) )!=null &&
      (glVertexAttrib2s = cast(PFNGLVERTEXATTRIB2SPROC)wglGetProcAddress( cast(char*)("glVertexAttrib2s") ) )!=null &&
      (glVertexAttrib2sv = cast(PFNGLVERTEXATTRIB2SVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib2sv") ) )!=null &&
      (glVertexAttrib3d = cast(PFNGLVERTEXATTRIB3DPROC)wglGetProcAddress( cast(char*)("glVertexAttrib3d") ) )!=null &&
      (glVertexAttrib3dv = cast(PFNGLVERTEXATTRIB3DVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib3dv") ) )!=null &&
      (glVertexAttrib3f = cast(PFNGLVERTEXATTRIB3FPROC)wglGetProcAddress( cast(char*)("glVertexAttrib3f") ) )!=null &&
      (glVertexAttrib3fv = cast(PFNGLVERTEXATTRIB3FVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib3fv") ) )!=null &&
      (glVertexAttrib3s = cast(PFNGLVERTEXATTRIB3SPROC)wglGetProcAddress( cast(char*)("glVertexAttrib3s") ) )!=null &&
      (glVertexAttrib3sv = cast(PFNGLVERTEXATTRIB3SVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib3sv") ) )!=null &&
      (glVertexAttrib4Nbv = cast(PFNGLVERTEXATTRIB4NBVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4Nbv") ) )!=null &&
      (glVertexAttrib4Niv = cast(PFNGLVERTEXATTRIB4NIVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4Niv") ) )!=null &&
      (glVertexAttrib4Nsv = cast(PFNGLVERTEXATTRIB4NSVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4Nsv") ) )!=null &&
      (glVertexAttrib4Nub = cast(PFNGLVERTEXATTRIB4NUBPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4Nub") ) )!=null &&
      (glVertexAttrib4Nubv = cast(PFNGLVERTEXATTRIB4NUBVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4Nubv") ) )!=null &&
      (glVertexAttrib4Nuiv = cast(PFNGLVERTEXATTRIB4NUIVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4Nuiv") ) )!=null &&
      (glVertexAttrib4Nusv = cast(PFNGLVERTEXATTRIB4NUSVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4Nusv") ) )!=null &&
      (glVertexAttrib4bv = cast(PFNGLVERTEXATTRIB4BVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4bv") ) )!=null &&
      (glVertexAttrib4d = cast(PFNGLVERTEXATTRIB4DPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4d") ) )!=null &&
      (glVertexAttrib4dv = cast(PFNGLVERTEXATTRIB4DVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4dv") ) )!=null &&
      (glVertexAttrib4f = cast(PFNGLVERTEXATTRIB4FPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4f") ) )!=null &&
      (glVertexAttrib4fv = cast(PFNGLVERTEXATTRIB4FVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4fv") ) )!=null &&
      (glVertexAttrib4iv = cast(PFNGLVERTEXATTRIB4IVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4iv") ) )!=null &&
      (glVertexAttrib4s = cast(PFNGLVERTEXATTRIB4SPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4s") ) )!=null &&
      (glVertexAttrib4sv = cast(PFNGLVERTEXATTRIB4SVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4sv") ) )!=null &&
      (glVertexAttrib4ubv = cast(PFNGLVERTEXATTRIB4UBVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4ubv") ) )!=null &&
      (glVertexAttrib4uiv = cast(PFNGLVERTEXATTRIB4UIVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4uiv") ) )!=null &&
      (glVertexAttrib4usv = cast(PFNGLVERTEXATTRIB4USVPROC)wglGetProcAddress( cast(char*)("glVertexAttrib4usv") ) )!=null &&
      (glVertexAttribPointer = cast(PFNGLVERTEXATTRIBPOINTERPROC)wglGetProcAddress( cast(char*)("glVertexAttribPointer") ) )!=null )
    {
      writek("accept GL_VERSION 2.0\n") ;
      ret=0x00002000;
    }else{
      writek("not accept GL_VERSION 2.0\n") ;
  }
    
      
  /* ----------------------------- GL_VERSION_2_1 ---------------------------- */
  if( (glUniformMatrix2x3fv = cast(PFNGLUNIFORMMATRIX2X3FVPROC)wglGetProcAddress( cast(char*)("glUniformMatrix2x3fv") ) )!=null &&
      (glUniformMatrix2x4fv = cast(PFNGLUNIFORMMATRIX2X4FVPROC)wglGetProcAddress( cast(char*)("glUniformMatrix2x4fv") ) )!=null &&
      (glUniformMatrix3x2fv = cast(PFNGLUNIFORMMATRIX3X2FVPROC)wglGetProcAddress( cast(char*)("glUniformMatrix3x2fv") ) )!=null &&
      (glUniformMatrix3x4fv = cast(PFNGLUNIFORMMATRIX3X4FVPROC)wglGetProcAddress( cast(char*)("glUniformMatrix3x4fv") ) )!=null &&
      (glUniformMatrix4x2fv = cast(PFNGLUNIFORMMATRIX4X2FVPROC)wglGetProcAddress( cast(char*)("glUniformMatrix4x2fv") ) )!=null &&
      (glUniformMatrix4x3fv = cast(PFNGLUNIFORMMATRIX4X3FVPROC)wglGetProcAddress( cast(char*)("glUniformMatrix4x3fv") ) )!=null )
    {
      writek("accept GL_VERSION 2.1\n") ;
      ret=0x00002100;
    }else{
      writek("not accept GL_VERSION 2.1\n") ;
  }
  
  return(ret) ;
}

