import win32.windows;
import win32.commctrl;
import std.string;
import win32frame.writek;
import win32frame.WindowObject ;
import win32frame.CommonControl;
import win32frame.CommonControlEx;

uint MAKELONG(ushort a, ushort b) {
        return cast(uint) ((b << 16) | a);
}

class UpDownCtrl : WindowObject {
  
  this(string name) {
    CommonControlEx ccex = new CommonControlEx(ICC_UPDOWN_CLASS) ;
    winc.lpszClassName  = cast(wchar*)(UPDOWN_CLASS) ;
    setStyle( (WS_CHILD | WS_VISIBLE ) ) ;
    super(name) ;
  }

  int getPos(){
    if( this.getHWND() != null ){
      return( sendmsg( UDM_GETPOS, 0,0 ) ) ;
    }
    return(-1) ;
  }

  int setPos(int pos, bool redraw=true){
    if( this.getHWND() != null ){
      return( sendmsg( UDM_SETPOS, cast(int)(redraw), pos ) ) ;
    }
    return(-1) ;
  }

  int setRange(int min, int max, bool redraw=true){
    if( this.getHWND() != null ){
      return( sendmsg( TBM_SETRANGE, cast(int)(redraw), MAKELONG(cast(ushort)(min),cast(ushort)(max)) ) ) ;
    }
    return(-1) ;
  }

  
}
