import win32.windows;
import win32frame.writek;
import win32frame.MainWindow;

class Win32Frame {
  MainWindow mainwindow ;
  MSG        msg;
  HWND       hmain;
  BOOL       bRet;
  HACCEL     hAccel;
  HINSTANCE  hInstance ;
  int        winX,winY,winW,winH ;
  int        style ;

  this(){
    winX=CW_USEDEFAULT ;
    winY=CW_USEDEFAULT ;
    winW=CW_USEDEFAULT ;
    winH=CW_USEDEFAULT ;
    style  =0 ;
  }

  int setMainWindow(MainWindow mainwin){
    mainwindow = mainwin ;
    return(0) ;
  }

  int setWindowPosition(int x, int y, int w, int h){
    winX=x ;
    winY=y ;
    winW=w ;
    winH=h ;
    return(0) ;
  }

  int setWindowStyle(int style){
    this.style=style ;
    return(0) ;
  }

  int start(){
    int ret ;
    hInstance = GetModuleHandle(null);
    ret=mainwindow.create( style, winX, winY, winW, winH, null,null) ;
    if( ret<0 ){
      writek("MainWindow open error.\n") ;
      return(-1) ;
    }
    hmain=mainwindow.getHWND() ;
    hAccel = LoadAccelerators(hInstance, cast(wchar*)("MYACCEL"));
    while( (bRet = GetMessage(&msg , null , 0 , 0)) != 0 ){
      if (bRet == -1) {
	break;
      } else {
	if (!TranslateAccelerator(hmain, hAccel, &msg)) {
	  TranslateMessage(&msg);
	  DispatchMessage(&msg);
	}
      }
    }
    return(0) ;
  }
}
